  //"use strict";

  document.title = "Keškomapa";
  
  // on first launch, after changing SplitScreen format in GSAK using dropdown menu, window object is messy and fails, so relaunch
  try
  {
    window.launchTest = window.launchTest || [];
  } catch(ex)
  {
    window.location.href = "gsak://%FF/macro/HTML_Custom_MapyCZ.gsk";
  }

  var mapadiv = document.getElementById("mapadiv");
  
//   if (mapadiv.clientHeight < 20)
//     alert([mapadiv.clientWidth, mapadiv.clientHeight]);
    
  // IE7-8 -- disable dragging of images
  if (JAK.Browser.client == "ie" && JAK.Browser.version <= 8)
    mapadiv.ondragstart = function() {return false;}  
  
  // alert("Verze IE: " + JAK.Browser.version);

  // fix some initial stuff
  var cachecode = window.cachecode || "";
  
  try
  {
    cachecode = decodeURIComponent(cachecode);
  }
  catch(ex)  /* GSAK incorrectly exports to URI some characters, let's fix it if the above fails */
  {        
    cachecode = cachecode.replace(/%91/g, '%E2%80%98'); // fixing character ‘
    cachecode = cachecode.replace(/%92/g, '%E2%80%99'); // fixing character ’
    cachecode = decodeURIComponent(cachecode);
  };  

  // check whether we can animate markers
  var doc = document.documentElement;
  
  var supportsAnimation = (('animation' in doc.style || 'MozAnimation' in doc.style || 'WebkitAnimation' in doc.style || 'OAnimation' in doc.style)
    && JAK.Browser.client != "opera");
  add_class(doc, (supportsAnimation ? "" : "no_") + "css_animation");  
  
  // supports transform?
  var supportsTransform = ('transform' in doc.style || 'msTransform' in doc.style || 'MozTransform' in doc.style || 'WebkitTransform' in doc.style || 'OTransform' in doc.style);
  add_class(doc, (supportsTransform ? "" : "no_") + "css_transform");  

  // supports transition?
  var supportsTransition = ('transition' in doc.style || 'msTransition' in doc.style || 'MozTransition' in doc.style || 'WebkitTransition' in doc.style || 'OTransition' in doc.style);
  add_class(doc, (supportsTransition ? "" : "no_") + "css_transition");
  
  
  // detekce GSAKu
  window.isGSAK = !!window.isGSAK;

  if (!window.isGSAK)
    add_class(doc, "notGSAK");
    
  window.gsakTwoColumnsMode = contains_class(document.body, "gsakTwoColumnsMode");  

  // detekce GeoSetteru
  window.isGeoSetter = !!window.isGeoSetter;
  
  if (window.isGeoSetter)
    add_class(doc, "isGeoSetter");
  
  // detekce embedded verze  
  if (window.isGSAK || window.isGeoSetter)
    JAK.Browser.embedded = true;  
  
  if (JAK.Browser.client == "ie" /*&& JAK.Browser.version <= 11*/)   /* detekce dle různých parametrů, nefunguje v IE8 */
  {
    if (window.doNotTrack || window.msDoNotTrack || window.msPointerEnabled || window.pointerEnabled)
      JAK.Browser.embedded = false;
  }  
  else if (JAK.Browser.client != "ie")                               /* pokud není prohlížeč IE, tak není nikdy embedded */
  {
    JAK.Browser.embedded = false;
  }

  // show logger on testing
  window.testing = !!window.testing;
  
  if (window.testing)
    document.getElementById("idlogger").style.display = "";

  // set ie version (for animations)
  if (JAK.Browser.client == "ie")
  {
    if(JAK.Browser.version <= 8)
      add_class(doc, "ie_lte8");
      
    add_class(doc, "ie" + JAK.Browser.version);
  }
  
  add_class(doc, JAK.Browser.client);

  //*******************************************************************************************************************
  var translations = 
  {
    /* mapy.cz control names */
    "Change Map" : {"Czech": "Změnit mapu"},    
    "World" : {"Czech": "Svět"}, 
    "Country" : {"Czech": "Státy"},
    "State" : {"Czech": "Kraje"},
    "County" : {"Czech": "Města"},
    "Town" : {"Czech": "Obce"},
    "Street" : {"Czech": "Ulice"},
    "House" : {"Czech": "Domy"},
    "Zoom In" : {"Czech": "Přiblížit"},
    "Zoom Out" : {"Czech": "Oddálit"},
    
    /* bubble */
    "Open in GSAK" : {"Czech": "Otevřít v GSAKu"},
    "Open in Browser" : {"Czech": "Otevřít v prohlížeči"},
    
    "Has Comment" : {"Czech": "Obsahuje komentář"},    
      
    // sidebar
    "Filter" : {"Czech": "&nbsp;Filtr&nbsp;"},
    
    // copy button
    "Copy": {"Czech": "Zkopírovat"},
    "Select": {"Czech": "Označit text"},
    
    // coordinates box
    "Degrees" : {"Czech": "Stupně"},
    "Minutes" : {"Czech": "Minuty"},
    "Seconds" : {"Czech": "Vteřiny"},
    "Elevation" : {"Czech": "Nadmořská výška"},
    _coords_box_help :  {"English": "Press Q to open copy window.", "Czech": "Pro otevření kopírovacího okénka zmačkni Q."},    
    
    // ui
    "Close" : {"Czech": "Zavřít"},
      
    translate: function(str)
    {
      // 1 - try current GSAK language, 2 - try English, 3 - don't translate (return original argument)
      if (this[str])
        return (this[str][language] || this[str]["English"] || str);

      return str;    
    }
  };

  function tr(str)
  {
    return(translations.translate(str));
  }
  
  var CacheNames = 
  {
    "T": "Traditional Cache",
    "M": "Multi Cache",
    "U": "Mystery Cache",
    "B": "Letterbox",
    "R": "Earthcache",
    "I": "Wherigo",
    "Y": "Waymark",
    "W": "Webcam",
    "V": "Virtual Cache",
    "E": "Event",
    "Z": "Mega Event",
    "C": "CITO",
    "L": "Locationless (Reverse) Cache",
    "O": "Other",
    "A": "Project Ape",
    "G": "BenchMark",
    "X": "Maze Exhibit",
    "F": "L&F Event",
    "H": "Groundspeak HQ",
    "D": "L&F Celebration",
    "P": "Block Party",
    "J": "Giga Event",
    "VirtualStage": "Virtual Stage",
    "PhysicalStage": "Physical Stage",
    "ReferencePoint": "Reference Point",
    "FinalLocation": "Final Location",
    "Trailhead": "Trailhead",
    "ParkingArea": "Parking Area",
    "Corrected": "Corrected"
  }  
   
  //*******************************************************************************************************************

  // get settings from cookie
  function default_settings()
  { 
    var tl = this.transparent_layers = {};

    tl[SMap.DEF_BASE] =         {trail: 0, bike: 0, relief: 0, ortofoto: 0, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0};
    //this.transparent_layers[SMap.DEF_SMART_BASE] =   {hybrid: 0, trail: 0, bike: 0, relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0};
    tl[SMap.DEF_TURIST] =       {trail: 1, bike: 1, relief: 0, ortofoto: 0, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0};
    tl[SMap.DEF_TURIST_WINTER] ={trail: 0, bike: 0, relief: 0, ortofoto: 0, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0};
    tl[SMap.DEF_SUMMER] =       {bike: 0, relief: 0, ortofoto: 0, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0};
    tl[SMap.DEF_GEOGRAPHY] =    {trail: 0, bike: 0, relief: 0, ortofoto: 0, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0};
    //tl[SMap.DEF_SMART_TURIST] = {hybrid: 0, trail: 1, bike: 1, relief: 0};
    tl[SMap.DEF_OPHOTO] =       {hybrid: 1, trail: 1, bike: 1, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0};
    tl[SMap.DEF_SMART_OPHOTO] = {hybrid: 1, trail: 1, bike: 1, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0};
    tl[SMap.DEF_HISTORIC] =     {hybrid: 0, trail: 0, bike: 0, relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0};
    tl[SMap.DEF_OPHOTO0203] =   {hybrid: 1, trail: 1, bike: 1, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0};
    tl[SMap.DEF_OPHOTO0406] =   {hybrid: 1, trail: 1, bike: 1, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0};

    tl["VojMapIII_ID"] =        {hybrid: 0, trail: 1, bike: 1, relief: 0};
    tl["ZM10_ID"] =             {relief: 1, geocaches: 0, g_streetview: 0, boundaries: 0, trail: 1, bike: 1, ortofoto: 0, pano: 0, hybrid: 0};
    tl["ZM10_SJTSK_ID"] =       {};
    tl["Orto_CZ_ID"] =          {katastr: 0, def_budov: 0, def_parcel: 0, vrstevnice: 0};
    
    tl["IZS_ID"] =              {};
    tl["Vojenska_ID"] =         {};
    tl["Orto_50_ID"] =          {katastr: 0, def_budov: 0, def_parcel: 0, vrstevnice: 0};
    
    tl["GSatellite_ID"] =       {trail: 0, bike: 0, pano: 0, g_terrain: 0, geocaches: 0, g_hybrid: 1, g_streetview: 0, boundaries: 0};
    tl["GMaps_ID"] =            {relief: 0, trail: 0, bike: 0, pano: 0, g_ortofoto: 0, g_terrain: 0, geocaches: 0, g_streetview: 0, boundaries: 0};
    tl["GTerrain_ID"] =         {relief: 0, trail: 0, bike: 0, pano: 0, g_ortofoto: 0, g_terrain: 0, geocaches: 0, g_streetview: 0, boundaries: 0};
    tl["MapBoxTerrain_ID"] =    {relief: 0, trail: 0, bike: 0, pano: 0, g_ortofoto: 0, g_terrain: 0, geocaches: 0, g_streetview: 0, boundaries: 0};
    tl["OSM_ID"] =              {relief: 0, trail: 0, bike: 0, pano: 0, g_ortofoto: 0, g_terrain: 0, geocaches: 0, g_hybrid: 0, g_streetview: 0, boundaries: 0};
    tl["OSMCyclo_ID"] =         {relief: 0, trail: 0, bike: 0, pano: 0, g_ortofoto: 0, g_terrain: 0, geocaches: 0, g_hybrid: 0, g_streetview: 0, boundaries: 0};
    tl["MTBMap_ID"] =           {relief: 0, g_ortofoto: 0, geocaches: 0, g_hybrid: 0, g_streetview: 0, boundaries: 0};
    tl["FreemapSK_ID"] =        {relief: 0, g_ortofoto: 0, geocaches: 0, g_hybrid: 0, g_streetview: 0, boundaries: 0};
    //tl["UMP_Poland_ID"] =           {g_ortofoto: 0, geocaches: 0, g_hybrid: 0, g_streetview: 0};

    tl["Muller_ID"] =    {};

    //tl["ZM10_Slovakia_ID"] =    {};
    //tl["Poland_ID"] =       {};
    
    // *** smazat poté, co bude opět fungovat vrstva reliéf ***
    if (!supportsTransform)
    {
      for (layer in tl)
        delete tl[layer].relief;
    } 
    
    if (supportsTransform)
    {
      SMap.Util.mergeObject({vrstevnice: 0}, tl[SMap.DEF_BASE]);
      //SMap.Util.mergeObject({}, tl[SMap.DEF_TURIST]);
      //SMap.Util.mergeObject({}, tl[SMap.DEF_TURIST_WINTER]);
      //SMap.Util.mergeObject({}, tl[SMap.DEF_SUMMER]);
      //SMap.Util.mergeObject({}, tl[SMap.DEF_GEOGRAPHY]);
      SMap.Util.mergeObject({relief2: 0, vrstevnice: 0, katastr: 0, def_budov: 0, def_parcel: 0}, tl[SMap.DEF_OPHOTO]);
      SMap.Util.mergeObject({relief2: 0, vrstevnice: 0, katastr: 0, def_budov: 0, def_parcel: 0}, tl[SMap.DEF_SMART_OPHOTO]);
      //SMap.Util.mergeObject({}, tl[SMap.DEF_HISTORIC]);
      SMap.Util.mergeObject({relief2: 0, vrstevnice: 0, katastr: 0, def_budov: 0, def_parcel: 0}, tl[SMap.DEF_OPHOTO0203]);
      SMap.Util.mergeObject({relief2: 0, vrstevnice: 0, katastr: 0, def_budov: 0, def_parcel: 0}, tl[SMap.DEF_OPHOTO0406]);
      
      SMap.Util.mergeObject({relief2: 0, vrstevnice: 0, katastr: 0, def_budov: 0, def_parcel: 0}, tl["GSatellite_ID"]);
      SMap.Util.mergeObject({vrstevnice: 0}, tl["GMaps_ID"]);
      SMap.Util.mergeObject({vrstevnice: 0}, tl["OSM_ID"]);
      
      SMap.Util.mergeObject({relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0, trail: 0, bike: 0, hybrid: 0, ortofoto: 0, pano: 0}, tl["VojMapIII_ID"]);
      SMap.Util.mergeObject({}, tl["ZM10_ID"]);
      SMap.Util.mergeObject({relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0, trail: 0, bike: 0, ortofoto: 0, pano: 0}, tl["ZM10_SJTSK_ID"]);
      SMap.Util.mergeObject({relief2: 0, geocaches: 0, g_streetview: 0, boundaries: 0, trail: 0, bike: 0, hybrid: 0, pano: 0}, tl["Orto_CZ_ID"]);
      SMap.Util.mergeObject({relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0, trail: 0, bike: 0, ortofoto: 0, pano: 0}, tl["IZS_ID"]);
      SMap.Util.mergeObject({relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0, trail: 0, bike: 0, ortofoto: 0, pano: 0}, tl["Vojenska_ID"]);
      //SMap.Util.mergeObject({geocaches: 0, g_streetview: 0, boundaries: 0, /*g_ortofoto: 0, */relief: 0}, tl["Poland_ID"]);
      SMap.Util.mergeObject({relief2: 0, geocaches: 0, g_streetview: 0, boundaries: 0, trail: 0, bike: 0, hybrid: 0, ortofoto: 0, pano: 0}, tl["Orto_50_ID"]);
      SMap.Util.mergeObject({boundaries: 0}, tl["Muller_ID"]);
      
      //SMap.Util.mergeObject({geocaches: 0, g_streetview: 0, g_ortofoto: 0, g_terrain: 0}, tl["ZM10_Slovakia_ID"]);
    }
    else
    {
      //SMap.Util.mergeObject({}, tl["GSatellite_ID"]);
      //SMap.Util.mergeObject({}, tl["GMaps_ID"]);
      //SMap.Util.mergeObject({}, tl["GTerrain_ID"]);
      //SMap.Util.mergeObject({}, tl["OSM_ID"]);
      //SMap.Util.mergeObject({}, tl["OSMCyclo_ID"]);
    }
    
    this.zm10_sjtsk = false; 
        
    this.startCoords = SMap.Coords.fromWGS(50, 14.8).format();
    this.zoom = 9;
    
    if (isGSAK)
      this.zoom = 17;
    
    this.map = JAK.Browser.embedded ? SMap.DEF_SMART_OPHOTO : SMap.DEF_SUMMER;
    this.display_bubble = false;
    this.display_animation = true;
    this.display_circles = false;
    this.display_spider = false;
    this.display_scale = (JAK.Browser.client == "ie" && JAK.Browser.version <= 9) ? false : true;
    this.display_overview_map = false;
    this.display_coordinates_box = false;
    this.display_search_field = true;
    this.display_coordinate_grid = false;
    this.display_coordinate_grid_sjtsk = false;
    
    this.hide_children = false;
    this.hide_parents = false;
    this.private_hide = false;
    this.display_mark_userflagged_parents = false;
    this.display_mark_userflagged_children = false;
    this.hide_finals_family = false;
    this.hide_status_archived = false;
    this.hide_status_disabled = false;
    this.hide_status_owned = false;
    this.hide_status_found = false;
    this.hide_status_else = false;
    
    this.hide_flagged_parents = false;
    this.hide_flagged_children = false;
    this.hide_selected = false;    
        
    this.version = macro_version;
    this.streetview_width = 50 /* percent */;
    this.display_polygon_bubble = true;
    
    this.minimap_on = false;
    this.minimap_width = 250;
    this.minimap_height = 250;
    this.minimap_map = "_same_as_map";
    this.minimap_zoom = "-5";    
    
    if (window.gsakTwoColumnsMode)
    {
      this.minimap_width = 170;
      this.minimap_height = 170;
    }
  };

  var transparentLayers = 
  {
    "hybrid": SMap.DEF_HYBRID, "trail": SMap.DEF_TRAIL, "bike": SMap.DEF_BIKE, "relief": SMap.DEF_RELIEF, "ortofoto": "MapyCZ_OPHOTO_Sub",
    "katastr": "Katastr", "def_budov": "DefinicniBodyBudov", "def_parcel": "DefinicniBodyParcel",
    "vrstevnice": "Vrstevnice_ID", "boundaries": "Boundaries_ID",
    "g_hybrid": "GHybrid_ID", "g_streetview": "GStreetView_ID", "pano": "pano_ID",
    "relief2": "Relief2_ID", "g_terrain": "LandShading_ID", "g_ortofoto": "GSatelliteSub_ID",
    "geocaches": "GeocachesMap_ID"
  }

  //****************************
  
  var mapCookies = new function mapCookies()
  {
    this.compressStrings =
    [
      ',"katastr":0,"def_budov":0,"def_parcel":0',
      '"relief":0,"trail":0,"bike":0',
      ',"pano":0',
      '":false,"',
      ',"geocaches":0,"g_streetview":0,"boundaries":0',
      '":0,"',
      '":1,"',
      '":',
      ',"',
      '"',
      'WhybridQtrailQbikeQreliefR0~UvrstevniceR0AL',
      'geocachesNg_hybridNg_streetviewNboundaries'
    ];

    // unused in settings as of 6.3.2015: ~qAELNQRUW
    // frequency analyzer: http://www.characterfrequencyanalyzer.com/english/tfa_results.php    
    this.dictionary = ["~", "q", "A", "E", "L", "N", "Q", "R", "U", "W", "QA", "QB", "QC", "QD", "QE", "QF"];

    // **** encrypt cookie ****
    this.encrypt = function(cookie)
    {
      if (!cookie)
        return cookie;

      for (var i = 0; i < this.compressStrings.length; i++)
        cookie = cookie.replace(new RegExp(this.compressStrings[i], 'g'), this.dictionary[i]);

      return cookie;
    }
    
    // **** decrypt cookie ****
    this.decrypt = function(cookie)
    {
      if (!cookie)
        return cookie;

      for (var i = this.compressStrings.length - 1; i >= 0; i--)
        cookie = cookie.replace(new RegExp(this.dictionary[i], 'g'), this.compressStrings[i]);
        
      return cookie;
    }
    
    // **** load settings ****
    this.loadSettings = function()
    {
      // try proto, že při loadnutí jiné verze může být jiná dekryptovací funkce
      // -- a může se tedy dekryptovat na nesmysl, kde JSON.parse vyhodí chybu
      try
      {
        window.settings = JSON.parse(this.decrypt(read_cookie('gsak_maps_settings')));
        
        if (window.settings.version != macro_version)
          window.settings = new default_settings();
      }
      catch(e)
      {
        window.settings = new default_settings();
      };
      
      //window.settings = new default_settings();

      if(window.addToSettings)
        window.addToSettings(window.settings);    
    }
    
    // **** save settings ****
    this.saveSettings = function()
    {
      if (typeof m === 'undefined')
        return;
  
      // ** save settings **    
      var mapadiv = document.getElementById("mapadiv");
      if (!window.gsakOnlyOneCache) settings.hide_children = settings.hide_children_local;
      if (!window.gsakOnlyOneCache) settings.hide_parents = settings.hide_parents_local;

      settings.startCoords =  m.getCenter().format();
      settings.zoom = m.getZoom();
      
      // minimap
      if (window.minimapExitSaveSettings)
        minimapExitSaveSettings();
  
      this.writeSettings();  
    }
    
    // *** write settings to cookie ***
    this.writeSettings = function()
    {
      //clear_cookie('gsak_mapycz_settings_' + macro_version);
      clear_cookie('gsak_maps_settings');
      write_cookie('gsak_maps_settings', this.encrypt(JSON.stringify(settings)));

      //alert(escape(this.encrypt(JSON.stringify(settings))).length);

      /*** measure time - start (unloading the page) ***/
      clear_cookie('timer');
      
      if (window.testing)
        write_cookie('timer', new Date().getTime());      
    }
    
    // *** reset settings to default + restart the map ***
    this.resetSettings = function()
    {
      window.settings = new default_settings();
      this.writeSettings();
      window.location.reload(true);
    }
    
    // **** save settings on exit and sometimes every second (when unload doesn't hit on exit) ****
    var that = this;

    EventUtil.addHandler(window, 'unload', function() { that.saveSettings(); });

    // Opera doesn't fire unload event, so use interval instead
    if (JAK.Browser.client == "opera" || JAK.Browser.client == "safari")
    {
      window.setInterval(function() { that.saveSettings(); }, 1000);
    }    
  };  
    
  mapCookies.loadSettings();  

  // remove temp settings on start  
  delete settings.hide_children_local;
  delete settings.hide_parents_local;    
  
  toggleSetting("hide_children", (settings.hide_children && !window.gsakOnlyOneCache) ? "add" : "remove");
  toggleSetting("hide_parents", /*settings.hide_parents ? "add" :*/ "remove");
  toggleSetting("bubble", settings.display_bubble ? "add" : "remove");
  toggleSetting("animation", settings.display_animation ? "add" : "remove");
  toggleSetting("spider", settings.display_spider ? "add" : "remove");
  toggleSetting("coordinates_box", settings.display_coordinates_box ? "add" : "remove");
  toggleSetting("search_field", settings.display_search_field ? "add" : "remove");  
  toggleSetting("polygon_bubble", settings.display_polygon_bubble ? "add" : "remove");
  toggleSetting("mark_userflagged_parents", settings.display_mark_userflagged_parents ? "add" : "remove");
  toggleSetting("mark_userflagged_children", settings.display_mark_userflagged_children ? "add" : "remove");
  toggleSetting("coordinate_grid", settings.display_coordinate_grid ? "add" : "remove");
  toggleSetting("coordinate_grid_sjtsk", settings.display_coordinate_grid_sjtsk ? "add" : "remove");
   
  // variables for map
  var souradnice = [];
  
  var startCoords;
  
  if (!cachecode)
    startCoords = SMap.Coords.fromString(settings.startCoords);
  else
    startCoords = SMap.Coords.fromWGS(wp[cachecode].Latitude, wp[cachecode].Longitude);

  var m = new SMap(mapadiv, startCoords, settings.zoom);

  //toggleSetting("overview_map", settings.display_overview_map ? "add" : "remove");
  toggleSetting("scale", settings.display_scale ? "add" : "remove");

  var layers_to_add = 
  [
    SMap.DEF_SMART_OPHOTO,
    SMap.DEF_TURIST,
    SMap.DEF_TURIST_WINTER,
    SMap.DEF_SUMMER,
    SMap.DEF_GEOGRAPHY,    
    SMap.DEF_BASE,    
    SMap.DEF_OPHOTO0406,
    SMap.DEF_OPHOTO0203,
    "Orto_CZ_ID",
    "ZM10_ID",
    "ZM10_SJTSK_ID",
    "GSatellite_ID",
    "GMaps_ID",
    "GTerrain_ID",
    "MapBoxTerrain_ID",
    "OSM_ID",
    "OSMCyclo_ID",
    "MTBMap_ID",
    "IZS_ID",
    "FreemapSK_ID",
    "Vojenska_ID",    
    //"Orto_50_ID",
    "Muller_ID",    
    SMap.DEF_HISTORIC,
    "VojMapIII_ID"

    //"ZM10_Slovakia_ID",
    //"Poland_ID"
  ];
  
  if (window.addExtraLayers)
    window.addExtraLayers();
        
  // create default layers
  for (var i = 0; i < layers_to_add.length; i++)
    m.addDefaultLayer(layers_to_add[i]);
 
  // create transparent layers (last - so that they are not below)
  for (var layer in transparentLayers)
    m.addDefaultLayer(transparentLayers[layer]);
    
  var controls = {};
    
  function createDefaultMapControls(firstRun)
  {
    // premature run (run from toggle setting before this function)
    if (!window.controls)
      return;

    // delete all controls first
    if (firstRun !== true) /* fixes startup error (after switching from original listing generator) */
    {
      if (controls.zoomControl)    /* we need to call this first */
        controls.zoomControl.removeZoomMenu(); 
      
      // remove all controls
      for (var c in controls)
        m.removeControl(controls[c]);

      // reset object
      controls = {};
    }
    
    // ** add layer switch **/
    var layer_switch_left_offset = 10;
    var item_width = 65;
    
    // generate number of items (so that we fit on the screen)    
    var margin_left = layer_switch_left_offset + 8 + 12;  /* layer switch left: our margin + margin set by app + left arrow */
    var margin_right = 12; /* layer switch: right arrow */

    var available_width = mapadiv.offsetWidth - margin_left - margin_right;
    var scritems = Math.min(Math.floor(available_width / item_width) || 1, layers_to_add.length);

    controls.layerSwitch = new SMap.Control.Layer({items: scritems, page: scritems, width: item_width});

    for (var i = 0; i < layers_to_add.length; i++)
      controls.layerSwitch.addDefaultLayer(layers_to_add[i]);

    // *** add controls on the right ***
    if (scritems > 2)   /* don't add right controls when width too tight */
    {
     	// ** add zoom control **
     	var labels = {2: tr("World"), 5: tr("Country"), 8: tr("State"), 11: tr("County"), 14: tr("Town"), 17: tr("Street"), 20: tr("House")};
     	controls.zoomControl = new SMap.Control.Zoom(labels, {titles:[tr("Zoom In"), tr("Zoom Out")]}); 
      m.addControl(controls.zoomControl, {right:"15px", top:"50px"});
      
      // ** add orientation arrows **
      controls.CCWControl = new SMap.Control.Orientation({mode:"ccw"});
      controls.CWControl  = new SMap.Control.Orientation({mode:"cw"});
      
      m.addControl(controls.CCWControl, {right:"50px",top:"15px"});  /* ok top value: 27 */  
      m.addControl(controls.CWControl,  {right:"20px",top:"15px"});
    }

    // *** layer switch - finalize ***    
    // show layer switch (last because it needs to be on top - fixes IE7 problem)  
    m.addControl(controls.layerSwitch, {left: layer_switch_left_offset + "px", top: "10px"});

    // translate main caption    
    if (language != "Czech")
      document.querySelector('.layer-switch > button').innerHTML = tr("Change Map");
    
    // *** misc ***  
    // get click location (show windows)
    controls.mouseControl = new SMap.Control.Mouse(SMap.MOUSE_PAN + SMap.MOUSE_ZOOM + SMap.MOUSE_WHEEL);
    m.addControl(controls.mouseControl);
    
    // keyboard control
    controls.keyboardControl = new SMap.Control.Keyboard(SMap.KB_ZOOM | SMap.KB_PAN, {panAmount: (JAK.Browser.client == "opera") ? 250 : 40});
    m.addControl(controls.keyboardControl);

    // zoom square
    controls.zoomSquareControl = new SMap.Control.ZoomNotification();
    m.addControl(controls.zoomSquareControl);
    
    // *** overview map ***
    if (settings.display_overview_map)
    {
      controls.OverviewMapControl = new SMap.Control.Overview({});
      var bottom = settings.display_coordinates_box ? 110 : 25; // move upward if coordinate box visible
      m.addControl(controls.OverviewMapControl, {right:"0px", bottom: bottom + "px"});

      // make non-draggable
      disableDragging(controls.OverviewMapControl.getContainer());
    }
  }

  // set transparent layers on layer change 
  m.getSignals().addListener(window, "layer-change-before", function(e, elm)
  {
    var id = e.target;

    // save last map name to settings
    settings.map = id;

    // turn on/off transparent layers
    for (var layer in transparentLayers)
      toggleSetting(layer, settings.transparent_layers[id][layer] ? "add" : "remove");
  });

  // turn this on before activating the layer (otherwise the layer will be rendered twice - once by addControl below)
  m.addControl(new SMap.Control.Sync());

//   // turn on layer
//   m.getLayer(settings.map).enable();

  // map history (ctrl+z)
  var mapHistory = new function()
  {
    var that = this;
    this.stack = [];
    this.isBeingRestored = false;
    
    // map redraw - save history
    this.saveHistory = function()
    {
      // fix: prohlížeče (kromě IE) hodí jedno map-redraw-before ještě před nastavením CurrentMapId
      if (typeof m.CurrentMapId === 'undefined')
        return;
    
      var zoom = m.getZoom();
      var center = m.getCenter();
      var mapId = m.CurrentMapId;
      that.stack.push({zoom: zoom, center: center, mapId: mapId, selected: (window.selectedCaches || []).clone()});
    }
    
    this.reloadHistory = function()
    {
      if (!that.stack.length)
        return;

      // last state is current state, so pop it and get the next state after it
      var state = that.stack.pop();
      state = that.stack.pop() || state;

      // set flag, so that while restoring last state we don't activate history saving
      that.isBeingRestored = true;

      // change map type?
      if (state.mapId != m.CurrentMapId)
         m.switchMap(state.mapId);
      
      // restore center + zoom    
      m.setCenterZoom(state.center, state.zoom);
      
      // restore selected caches
      window.selectedCaches = state.selected;
      synchronizeSelected();

      that.isBeingRestored = false;
      
      // save current state to history
      that.stack.push(state);
    }
    
    this.removeLast = function()
    {
      if (that.stack.length >= 2)
        that.stack.pop();
    }
    
    this.eventHandler = function()
    {
      // save history only when not in process of restoring it
      if (that.isBeingRestored)
        return;
        
      that.saveHistory();
    }

    this.destroy = function()
    {
      m.getSignals().removeListener(that.ev1);
      m.getSignals().removeListener(that.ev2);
      m.getSignals().removeListener(that.ev3);      
    }
    
    this.ev1 = m.getSignals().addListener(window, "map-redraw-before", this.eventHandler);        /* zoom change, map move */
    this.ev2 = m.getSignals().addListener(window, "layer-switch-click-after", this.eventHandler); /* layer switch */
    this.ev3 = m.getSignals().addListener(window, "map-switch", this.eventHandler);               /* map switch */            
  }

  // turn on default map controls (+ re-generate them on window resize)
  createDefaultMapControls(true);
  EventUtil.addHandler(window, "resize", createDefaultMapControls);
  
  // add zoom selection control (CTRL version is for Opera to override gestures)
  m.addControl(new SMap.Control.Selection(4));
  m.addControl(new SMap.Control.Selection({ctrl: true, thickness: 4}));
  
  //********* misc processing *********//
  // get div of map area (element encompassing only map tiles)
  var mapAreaDiv = m.getContent();

  // set onmouseover to automatically focus (otherwise zooming may stop working after prompt or alt-tab)
  if (window.gsakTwoColumnsMode)
  JAK.Events.addListener(mapAreaDiv, 'mouseover', function()
  {
    window.focus();
  });

  // set focus also on mousedown (fixes focus problems in SplitScreen mode, where onmouseover focus is turned off)
  JAK.Events.addListener(mapAreaDiv, 'mousedown', function(){window.focus();});

  // load context menu on hovering over map
  var loadContextMenuHandler = EventUtil.addHandler(mapadiv, 'mouseover', function()
  {
    if (!window.contextMenuJSLoaded)
    {
      window.contextMenuJSLoaded = true;
      loadJS(basePath + "context_menu.js");
      loadCSS(basePath + "context_menu.css");
    }
    
    loadJS(basePath + "search_field.js");
    loadCSS(basePath + "search_field.css");

    // may break scripts if used before loading (currently used only in coordinates_box and SMap.Coords.fromString)
    //if (window.coordinatesUTMLoaded == false);
    //  loadJS(basePath + "coordinates_utm.js");
    
    EventUtil.removeHandler(loadContextMenuHandler);
    translate_strings();  
  });
  
      
  // *************
//   var div = document.getElementById("idlogger");
//   
//   div.innerHTML += "<div id='menu'>"
// 	div.innerHTML += "<ul>";
//   div.innerHTML += "<li>" + tr("Help") + "</li>"
//   
//   div.innerHTML += "</ul>";
//   div.innerHTML += "</div>";
  
//   log(div.innerHTML);





  
//   function clicky(e, elm) 
//   {
//     alert(e.target);
//     //alert(e.type + " - " + e.target.constructor.NAME);
//     
// //     var obj = document.getElementById ("m");
// //     if (obj.setActive) { obj.setActive ();}
// //     else {if (obj.focus) obj.focus (); else alert ("Your browser does not support this example!");}
// 
// 
//   }
// //     var keys=[];   
// //     //for (x in e.target._owner){keys.push(e.target._owner[x]);}
// //     for (var i in e.target._owner) { keys.push(i);}
// //     alert(keys); 
//   m.getSignals().addListener(window, "*", clicky); 

//     function clicked(e, elm) 
//    {
//   alert("hre");
//   //window.focus();
//       }
// 
//   JAK.Events.addListener( JAK.gel('mapadiv'), 'dblclick', window, 'clicked');
//   JAK.Events.addListener( JAK.gel('mapadiv'), 'gesturestart', window, 'clicked');
//   JAK.Events.addListener( JAK.gel('mapadiv'), 'mouseup', window, 'clicked');
//   JAK.Events.addListener( JAK.gel('mapadiv'), 'mousewheel', window, 'clicked');
//   JAK.Events.addListener( JAK.gel('mapadiv'), 'DOMMouseScroll', window, 'clicked');
//   JAK.Events.addListener( JAK.gel('mapadiv'), 'mousedown', window, 'clicked');

  //  JAK.Events.addListener(window, "mousedown", "*", "_mouseDown");
 
  // *************
  
  // fix column height on start
//   var h_left = document.getElementById('main_left_col').scrollHeight;
//   var h_right = document.getElementById('main_right_col').scrollHeight;
//   document.getElementById('main_left_col').style.height = Math.max(h_left, h_right) + 'px';
//   document.getElementById('main_right_col').style.height = Math.max(h_left, h_right) + 'px';

    
    
  //wp = {@@listings@@};
  
  /* get parent and all its children */
  function get_all_in_family(wp_code)
  {
    var parent = wp[wp_code].Parent || wp_code;
    var results = [parent];

    for (var code in wp)
    {
      if (wp[code].Parent == parent)
        results.push(code);
    }

    return results;
  }


  //***************************************************************************
  //**********        Draw 161m circles around points            **************
  //***************************************************************************
  
  var circle_layer = null;
  
  /* draw circles around all points */
  function draw_circles()
  {
    if (circle_layer)
      return;
  
    circle_layer = new SMap.Layer.Geometry("circleLayer");
    m.addLayer(circle_layer);

    for (var code in wp)
    {
      //log(wp[code].CacheType);
    
      if (wp[code].CacheType != "T" && wp[code].CacheType != "FinalLocation" && wp[code].CacheType != "PhysicalStage" && !wp[code].HasCorrected)
        continue;    
                                                                                                                                
      var center = SMap.Coords.fromWGS(wp[code].Latitude, wp[code].Longitude);
      var point_on_circle = center.projectPoint(0, 161);
      //var point_on_circle = SMap.Coords.fromWGS(project_point(wp[code].Longitude, wp[code].Latitude, 180, 161)[1], project_point(wp[code].Latitude, wp[code].Longitude, 180, 161)[0]);
      
      var circle = new SMap.Geometry(SMap.GEOMETRY_CIRCLE, null, [center, point_on_circle], {color: "#00f", opacity: 0.3, outlineWidth: 0} /* settings for IE8 only */);
      circle_layer.addGeometry(circle);
    }
    
    circle_layer.enable();
  }
  
  /* delete circles around points */
  function remove_circles()
  {
    if (!circle_layer)
      return;
      
    circle_layer.disable();
    m.removeLayer(circle_layer);
    circle_layer = null;
  }
  
  // display circles on start (if set in settings)
  
  
  if (settings.display_circles)
    toggleSetting("circles", "add")

  //***************************************************************************
  //********** Highlight WP and all its parent/children/siblings **************
  //***************************************************************************
  var selected = [];
  var last_selected = [];
  var marker_context_menu_handler;
  var spider_layer = 0;

  function highlight_all_related_wps(Code)
  {
    var Code = (typeof Code === 'string') ? Code : this["data-code"];
    var parent = wp[Code].Parent || Code;
    var Code_ID = wp[Code].id;
    var parent_ID = wp[parent].id;
    
    // clear last_selected array
    remove_class('.wp_last_selected', 'wp_code_last_selected');
    remove_class('.wp_last_selected', 'wp_last_selected');
    
    // set selected code + last selected code
    add_class('.code_' + Code_ID, 'wp_code_selected');
    add_class('.code_' + Code_ID, 'wp_code_last_selected');
    
    // set selected family + last selected family + save to array for later use
    add_class('.parent_' + parent_ID, 'wp_selected');
    add_class('.parent_' + parent_ID, 'wp_last_selected');
    
    // *** marker animation in IE8 and older ***
    var family = get_all_in_family(parent);
    
    if (!('transition' in doc.style || 'msTransition' in doc.style || 'MozTransition' in doc.style || 'WebkitTransition' in doc.style || 'OTransition' in doc.style))
    {    
      for (var i = 0; i < family.length; i++)
      {
        if (family[i] == Code)
          continue;
  
        var marker = wp[family[i]].marker.getContainer()[SMap.LAYER_MARKER];
        marker.style.top = (parseInt(marker.style.top.match(/-?\d+/)) - 13) + 'px';
      }
    }
 
    for (var i = 0; i < family.length; i++)
      selected.push(family[i]);

    last_selected = selected.concat();

    // *** add context menu ***
    if (typeof markerContextMenu !== 'undefined')
      marker_context_menu_handler = markerContextMenu(document.querySelector(".code_" + Code_ID), Code, parent);
    
    // *** draw lines from parent to all children ***
    
    // create geometry layer (if not already created)
    if (!settings.display_spider)
      return;
    
    if (!spider_layer)
    {
      spider_layer = new SMap.Layer.Geometry("spiderLayer");
      m.addLayer(spider_layer);
      spider_layer.enable()
    }

    // find all children draw spider lines to them from parent
    var points = get_all_in_family(Code);
  
    for (var i = 1; i < points.length; i++)
    {    
      // filter out N0 E0 points
      if (wp[points[i]].Latitude == 0 && wp[points[i]].Longitude == 0)
        continue;
    
      var line_start_end = 
      [
          SMap.Coords.fromWGS(wp[parent].Latitude, wp[parent].Longitude),
          SMap.Coords.fromWGS(wp[points[i]].Latitude, wp[points[i]].Longitude)
      ];

      var options = {color: "red", width: 2, outlineWidth: 0, opacity: 1} /* IE7-8 only, otherwise set in CSS */;
      var polyline = new SMap.Geometry(SMap.GEOMETRY_POLYLINE, null, line_start_end, options);
      spider_layer.addGeometry(polyline);
    } 
  }
  
  function unhighlight_all_related_wps()
  {
    var Code = this["data-code"];
    var parent = wp[Code].Parent || Code;
    var Code_ID = wp[Code].id;
    var parent_ID = wp[parent].id;    
    
    remove_class('.parent_' + parent_ID, 'wp_selected');
    remove_class('.parent_' + parent_ID, 'wp_code_selected');
    selected = [];
    
    // *** marker animation in IE8 and older ***
    var family = get_all_in_family(parent);
    
    if (!('transition' in doc.style || 'msTransition' in doc.style || 'MozTransition' in doc.style || 'WebkitTransition' in doc.style || 'OTransition' in doc.style))
    {    
      for (var i = 0; i < family.length; i++)
      {
        if (family[i] == Code)
          continue;
  
        var marker = wp[family[i]].marker.getContainer()[SMap.LAYER_MARKER];
        marker.style.top = (parseInt(marker.style.top.match(/-?\d+/)) + 13) + 'px';
      }
    }
    
    // *** remove context menu ***
    if (marker_context_menu_handler && document.getElementById('contextMenuWP').style.display != "block")
      contextMenu.removeContextMenu(marker_context_menu_handler);

    // *** remove spider lines from parent to children ***
    if (settings.display_spider && spider_layer)
    {
      spider_layer.disable();
      m.removeLayer(spider_layer);
      spider_layer = null;
    }
  }
  
  //log(document.location.hostname);
  //log(window.top.document.location.hostname);
  //document.domain = "xxx";
  //window.top.document.domain = "xxx";
  
  
  //log(window.top.document.domain);

  //***************************************************************************
  //                ************** Cards **************
  //***************************************************************************

  // hide/unhide map controls on card open/close (to prevent overlay issues) - IE7 only, elsewhere solved by CSS z-index
  if (JAK.Browser.client == "ie" && JAK.Browser.version <= 7)
  {
    m.getSignals().addListener(window, "card-open", function(e, target)
    {
      var noprint = document.querySelectorAll(".noprint");
      
      for (var i = 0; i < noprint.length; i++)
        noprint[i].style.visibility = "hidden";
      
      // leave minimap open
      if (window.minimap)
        window.minimap._dom.container.style.visibility = "visible";
    });
    
    m.getSignals().addListener(window, "card-close", function()
    {
      var noprint = document.querySelectorAll(".noprint");
      
      for (var i = 0; i < noprint.length; i++)
        noprint[i].style.visibility = "visible";
    });
  }
  
  // use this to fix Webkit problem (double calling the function)
  var cards_created = {};  
  
  // create card + generate on-hover text
  function create_card() 
  {
    var Code = this["data-code"];
    var parent = wp[Code].Parent || Code;
                                    
    var text = "";                  
                                    
    // generate text for children   
    if (parent != Code)             
    {    
      // child icon                 
      var child_text = "<span class='cache_icon cacheimg_child cacheimg_" + wp[Code].CacheType + "' title='" + CacheNames[wp[Code].CacheType] + "'></span>";
                                    
      // child Code                 
      child_text += "<span class=cache_code>" + Code + "</span>";
      
      // child Coordinates
      child_text += "<span class=coords>(" + wp[Code].CoordsFormatted + ")</span>";
                                    
      // child Name                 
      child_text += "<span class=cache_name_ter_dif><span class=cache_name>" + wp[Code].Name  + "</span></span>";
                                    
      // child Comment              
      child_text += "<div class=child_comment>" + wp[Code].Comment + "</div>";
                                    
      // put to DIV                 
      text = text + "<div class=child_wp_text>" + child_text + "</div>"
    }                               
                                    
    // parent icon
    var parent_text = "<span class='cache_icon cacheimg_parent cacheimg_" + wp[parent].CacheType + "' title='" + CacheNames[wp[parent].CacheType] + "'></span>";
                                    
    // parent Code                  
    var cache_code = "<span class='cache_code status_" + wp[parent].Status + "'>" + parent + "</span>";
    parent_text += cache_code;
             
    // parent Coordinates
    var cache_coords = "<span class=coords>(" + wp[parent].CoordsFormatted + ")</span>";
    parent_text += cache_coords;
                                    
    // parent Name + Terrain/Difficulty + Container + OwnerName + PlacedDate
    var cache_ter_dif = "<span class=cache_name>" + wp[parent].Name + "</span>";
    cache_ter_dif += " (<span class=wp_diff>" + wp[parent].Difficulty + "</span>";
    cache_ter_dif += "/<span class=wp_terr>" + wp[parent].Terrain + " </span>";
    cache_ter_dif += "<span class=wp_container>" + wp[parent].Container + "</span>,"
    cache_ter_dif += "<span class=wp_owner> by " + wp[parent].OwnerName + "</span>,"; 
    cache_ter_dif += "<span class=wp_placed_date> " + wp[parent].PlacedDate + "</span>)";
    
    parent_text += "<span class=cache_name_ter_dif>" + cache_ter_dif + "</span>";
    
    // handle waymarks
    if (wp[parent].WaymarkCategoryIcon)
    {
      parent_text = "<img class='cache_icon cacheimg_parent' src=\"" + wp[parent].WaymarkCategoryIcon 
        + "\" title='" + wp[parent].WaymarkCategory.replace("'", "").replace("\\", "|") + "'>";
    
      // parent Code                  
      parent_text += cache_code;
               
      // parent Coordinates
      parent_text += cache_coords;
      
      var cache_ter_dif = "<span class=cache_name>" + wp[parent].Name + "</span>";
      cache_ter_dif += "<span class=wm_category> " + wp[parent].WaymarkCategory + "</span> (";
      
      if (wp[parent].OwnerName != wp[parent].WaymarkCategory)
        cache_ter_dif += "<span class=wp_owner>by " + wp[parent].OwnerName + "</span>, ";
      
      cache_ter_dif += "<span class=wp_placed_date>" + wp[parent].PlacedDate + "</span>)";
      parent_text += "<span class=cache_name_ter_dif>" + cache_ter_dif + "</span>";
    }
                                
    // "Open in ..." URLs           
    parent_text += "<div class=open_cache><a class='url_gsak button GSAK_Only' href='gsak://%FF/Search/" + parent + "'>" + tr("Open in GSAK") + "</a>";
    parent_text += "<a class='url_gc button' href='" + wp[parent].Url + "' target=_blank>" + tr("Open in Browser") + "</a></div>";
                                
    // parent ShortDescription / LongDescription
    if (parent == Code)             
      parent_text += "<div class=listing>" + (wp[parent].ShortDescription ? (wp[parent].ShortDescription + "<br>") : "") + wp[parent].LongDescription + "</div>";
                                    
    // put to DIV                   
    text = "<div class=wp_text>" + text + "<div class='parent_wp_text parent_wp_text_cachetype_" + wp[parent].CacheType + "'>" + parent_text + "</div></div>"
                                  
    // generate Card               
    var c = new SMap.Card();        
    c.setSize(311, null); /* Šířka (default: 311px, null results in default value), výška */
    c.getBody().style.backgroundColor = 'white';
    c.getBody().innerHTML = text;   
    wp[Code].marker.decorate(SMap.Marker.Feature.Card, c);
    
    // *** make waypoint draggable ***
    wp[Code].marker.decorate(SMap.Marker.Feature.Draggable);
    
    // *** create on-hover comment ***
    var hover_title = "";
    var dif_ter = parent + ", <span class='dif_ter_cont'>" 
      + wp[parent].Difficulty + "/" + wp[parent].Terrain + " " + wp[parent].Container + "</span>, by " + wp[parent].OwnerName;
    
    // special text for Waymarks  
    if (wp[Code].WaymarkCategory)
    {
      dif_ter = parent + ((wp[parent].OwnerName !== wp[parent].WaymarkCategory) ? (", by " + wp[parent].OwnerName) : "");    
    }  
      
    var status = "<span class='status'>" + (wp[parent].Status == 'T' ? " (Disabled)" : (wp[parent].Status == 'X' ? " (Archived)" : "")) + "</span>";
    
    // child
    if (parent != Code)
      hover_title = Code + ": " + "<span class='name'>" + wp[Code].Name + "</span>"
       + status + " (<span class='parent_name'>" + wp[parent].Name + "</span> - " + dif_ter + ")"
       + (wp[Code].Comment ? "<span class='has_comment'> [" + tr("Has Comment") + "]</span>" : "");
    // parent
    else
      hover_title = "<span class='name'>" + wp[Code].Name + "</span>" + status 
      + (wp[Code].WaymarkCategory ? ("<span class='wm_category'> " + wp[Code].WaymarkCategory + "</span>") : "") 
      + " (" + dif_ter + ")"

    // create bubble
    var bubble = new SMap.Bubble({html: hover_title, className: "on_hover_bubble"/*, alwaysShow: true*/});
    wp[Code].marker.decorate(SMap.Marker.Feature.Bubble, bubble);
     
    // *** turn off onmouseover (otherwise it won't show Card) and switch to second function  ***
    this.onmouseover = highlight_all_related_wps;  
    highlight_all_related_wps(Code);
  }

  //***************************************************************************
  //                ************** Markers **************
  //***************************************************************************  

  // markers - prepare
  var marker_layer = new SMap.Layer.Marker("markers");

  // deal with Corrected Coordinates + assing ID to all points + load WM
  var i = 0;
  
  function loadCaches(wp)
  {
    for (var Code in wp)
    {
      wp[Code].CoordsFormatted = SMap.Coords.fromWGS(wp[Code].Latitude, wp[Code].Longitude).format("WGS84", "min");

      // změny názvů waypointů 2014 - oprava pokud mame starsi verzi GSAKu
      if (wp[Code].CacheType === "QuestiontoAnswer")
        wp[Code].CacheType = "VirtualStage";      
      else if (wp[Code].CacheType === "StagesofaMulticache")
        wp[Code].CacheType = "PhysicalStage";
    
      if (wp[Code].HasCorrected)
      {
        wp["CC" + Code] = JSON.parse(JSON.stringify(wp[Code]));
        wp["CC" + Code].Latitude = wp["CC" + Code].LatOriginal;
        wp["CC" + Code].Longitude = wp["CC" + Code].LonOriginal;
        wp["CC" + Code].HasCorrected = 0;
        wp["CC" + Code].Parent = Code;
        wp["CC" + Code].CacheType = "Corrected";
        wp["CC" + Code].CoordsFormatted = SMap.Coords.fromWGS(wp["CC" + Code].Latitude, wp["CC" + Code].Longitude).format("WGS84", "min");
        wp["CC" + Code].Comment = "";
        wp["CC" + Code].id = ++i;
      }
      
      wp[Code].id = wp[Code].id || ++i;
    }
    
    //window.setInterval(function(){log(typeof waymarkNames);}, 0);
    
    // go through all Codes and create markers for them

    //var markersToAdd = [];
    
    for (var Code in wp)
    {
      var coordinates = SMap.Coords.fromWGS(wp[Code].Latitude, wp[Code].Longitude);
      
      // get parent code
      var Code_ID = wp[Code].id;
      var parent = wp[Code].Parent || Code;
  
      var bubble = (parent == Code) ? wp[parent].Name : (Code + ": " + wp[Code].Name);
      var div_class_name = "wp_marker" + " wp_" + ((Code == parent) ? "parent" : "child")
         + (wp[Code].HasCorrected ? (" wp_corrected_" + wp[Code].HasCorrected) : "") 
         + " parent_" + wp[parent].id + " code_" + Code_ID + " status2_" + wp[parent].Status2 + " status_" + wp[parent].Status
         + " CacheType_" + wp[Code].CacheType + " ParentCacheType_" + wp[parent].CacheType
         + ((wp[parent].UserFlag) ? " flagged_parent" : "")
         + ((wp[Code].Parent && wp[Code].UserFlag && wp[Code].CacheType != "Corrected") ? " flagged_child" : "");

      var outer_div = JAK.mel("div", 
      {
        /* use this to find out whether we hover on marker or on bubble - and to display extended bubble only on hovering over marker*/ 
        innerHTML: "<div class='wp_images'>"

        /* images + bubbles */    
        + "<div class='bg'></div><div class='main'></div><div class='fg'></div><div class='draw_selected_fg'></div></div><div class='simple_bubble'>" + bubble + "</div>"
        + /* add flagged divs just for IE7 */ (((JAK.Browser.client == "ie") && (JAK.Browser.version <= 7)) ? "<div class='flag_parent'></div><div class='flag_child'></div>" : ""),

        /* misc */ 
        className: div_class_name, "data-code": Code, onmouseover: create_card, onmouseout: unhighlight_all_related_wps
      });
  
      // Waymarks: get category
      if (wp[Code].CacheType === "Y")
      {
        // custom (our) version
        var catname = wp[Code].ShortDescription.match(/<!--WM_Category:(.*?)-->$/);
        
        if (catname && wp[Code].ShortDescription[0] == ':')
          wp[Code].ShortDescription = wp[Code].ShortDescription.replace(/^: /, "");  
  
        // GeoGet version
        catname = catname || wp[Code].CacheTypeWM;
        
        // standard GroundSpeak version
        if (!catname)
        {
          catname = wp[Code].ShortDescription.match(/^(.+?)(?=:)/);
          
          if (catname)
            wp[Code].ShortDescription = wp[Code].ShortDescription.replace(catname[0] + ": ", "");
        }
        
        if (catname)
        {
          catname = wp[Code].CacheTypeWM ? catname : catname[1];
          wp[Code].WaymarkCategory = catname;
  
          // replace special characters
          catname = catname.replace("<", "[less than]");
          catname = catname.replace(">", "[greater than]");
          catname = catname.replace(":", "[colon]");
          catname = catname.replace("\"", "[double quote]");
          catname = catname.replace("/", "[forward slash]");
          catname = catname.replace("\\", "[backslash]");
          catname = catname.replace("|", "[vertical bar]");
          catname = catname.replace("?", "[question mark]");
          catname = catname.replace("*", "[asterisk]");
  
          var catcode = "Icons2/" + catname;
          
          add_class(outer_div, "wm_icon");
          wp[Code].WaymarkCategoryIcon = basePath + "Images/Waymarking/" + catcode + ".gif";
          
          var div = outer_div.firstChild.childNodes[2];
          div.innerHTML = "<img src=\"" + wp[Code].WaymarkCategoryIcon + "\">";
  
          // remove icon when the image couldn't be loaded
          div.firstChild.onerror = function()
          {
             if (!div.firstChild)
              return;
             
             div.firstChild.onerror = null;
             div.firstChild.src = "";
             remove_class(outer_div, "wm_icon");
             div.removeChild(div.firstChild);
             delete wp[Code].WaymarkCategoryIcon;
             delete wp[Code].WaymarkCategory;
          };
        }
      }    
  
      // finalize
      var options = {url:JAK.mel("div").appendChild(outer_div)};
      var marker = new SMap.Marker(coordinates, "myMarker" + Code_ID, options);
      
      wp[Code].marker = marker;
      marker_layer.addMarker(marker);
      //markersToAdd.push(marker);
      
      if (!!parseFloat(wp[Code].Longitude || !!parseFloat(wp[Code].Latitude)))
        souradnice.push(coordinates);
    }
    
    //marker_layer.addMarker(markersToAdd);
  }

  loadCaches(wp);
  
  var setCenterZoomFromCaches = function()
  {
    // set zoom and location to show all caches (if we have more than one cache or are not in GSAK)
    if (!window.gsakOnlyOneCache && souradnice.length)
    {
      // based on number of points, either zoom to reference point (large number of points) or show all (small number of points) 
      if (souradnice.length > 350)
      {
        // get current reference point
        var referencePoint = SMap.Coords.fromWGS(refLat, refLon);
        
        // get nearest zoom of this map to mapy.cz ophoto map, zoom level 11
        var nearestZoom = m.getNearestZoom({layerFrom: SMap.DEF_OPHOTO, zoomFrom: 11, layerTo: settings.map});
        m.setCenterZoom.apply(m, [referencePoint, nearestZoom]);
      }
      else
        m.setCenterZoom.apply(m, m.computeCenterZoom(souradnice));
    }
  }
  
  setCenterZoomFromCaches();

  // turn on layer
  m.getLayer(settings.map).enable();
  mapHistory.saveHistory(); /* initial save: put after centering view procedure above, so that we don't save previous/initial state */

  // enable marker layer
  m.addLayer(marker_layer);
  marker_layer.enable();

  // set cursor (sometimes it doesn't update properly)
  document.getElementById("mapadiv").style.cursor = "move";
  
  // private hide markers
  if (settings.private_hide) toggleSetting("private_hide", "add");
  
  // show only finals and/or Corrected Coordinates (when available either)
  if (settings.hide_finals_family) toggleSetting("hide_finals_family", "add");
    
  // hide archived, disabled, found, owned, else
  if (settings.hide_status_archived) toggleSetting("hide_status_archived", "add");
  if (settings.hide_status_disabled) toggleSetting("hide_status_disabled", "add");
  if (settings.hide_status_found) toggleSetting("hide_status_found", "add");
  if (settings.hide_status_owned) toggleSetting("hide_status_owned", "add");
  if (settings.hide_status_else) toggleSetting("hide_status_else", "add");
  if (settings.hide_flagged_parents) toggleSetting("hide_flagged_parents", "add");
  if (settings.hide_flagged_children) toggleSetting("hide_flagged_children", "add");
  if (settings.hide_selected) toggleSetting("hide_selected", "add");      

  //***************************************************************************
  //           ************** Marker handling **************
  //*************************************************************************** 
    
  // function for dragging waypoints
  function marker_drag_stop(e)
  {
    var div = m.getContainer();

    var marker = e.target;
    var Code = marker.getContainer()[SMap.LAYER_MARKER]["data-code"];
    
    // not a cache marker?
    if (!Code)
      return;

    var parent = wp[Code].Parent || Code;

    // ALT is pressed -> leave marker where it was dragged to
    if (contains_class(div, "key_down_alt"))
    {
      // save coordinates
      wp[Code].dragged = marker.getCoords();
      souradnice.push(marker.getCoords());
        
      // remove pressed alt class (onkeyup doesn't fire, when we do it while dialog is present)
      remove_class(div, "key_down_alt"); 
    }

    // ALT is not pressed -> return marker to its original location
    else
    {
      marker.setCoords(new SMap.Coords.fromWGS(wp[Code].Latitude, wp[Code].Longitude));
      delete wp[Code].dragged;
    }
  }

  m.getSignals().addListener(window, "marker-drag-stop", marker_drag_stop);
  
  // function for deleting waypoint(s)
  function delete_waypoint(points)
  {
    for (var codes = points instanceof Array ? points : [points], i = 0; i < codes.length; i++)
    {
      marker_layer.removeMarker(wp[codes[i]].marker);
      delete wp[codes[i]];
      
      if (selected.indexOf(codes[i]) != -1)
        selected.remove(selected.indexOf(codes[i]));
    
      if (last_selected.indexOf(codes[i]) != -1)
        last_selected.remove(selected.indexOf(codes[i]));
    }
    
    toggleSetting("circles", settings.display_circles ? "add" : "remove");
    toggleSetting("spider", settings.display_spider ? "add" : "remove");
    
    // pokud je zaplé Street View v3, tak v něm znovu načteme všechny kešky
    if (window.svObjekt && window.svObjekt.addCaches)
      window.svObjekt.addCaches();
  }    

  //***************************************************************************
  //           ************** Keyboard handling **************
  //***************************************************************************
  
  function processKeys(key, e)
  {
    // Y - display marker bubble and hide it on next Y press
    if (key == "Y" && !e.ctrlKey)
      toggleSetting("bubble", "toggle");
          
    // X - hide all markers (and show them on next X press)
    // if any WP is selected, then don't hide it and its family
    else if (key == "X" && !e.ctrlKey)
      toggleSetting("hide", "toggle");
    
    // C - hide all children (and show them on next C press)
    else if (key == "C" && !e.ctrlKey)
      toggleSetting("hide_children", "toggle");

    // P - hide all parents (and show them on next P press)
    else if (key == "P" && !e.ctrlKey)
      toggleSetting("hide_parents", "toggle");
      
    // SHIFT+CTRL+ALT + P - hide checked children for not found + unchecked children for found + unchecked parking areas 
    else if (key == "P" && e.ctrlKey && e.shiftKey && e.altKey)
      toggleSetting("private_hide", "toggle");

    // L - draw lines from parent to children  
    else if (key == "L" && !e.ctrlKey)
      toggleSetting("spider", "toggle");
      
    // R - draw 161m radius around physical points (Traditional Cache, FL, ST)
    else if (key == "R" && !e.ctrlKey && !e.shiftKey && !e.altKey)
      toggleSetting("circles", "toggle");
      
    // SHIFT + A - display/hide marker animation
    else if (key == "A" && e.shiftKey && !e.ctrlKey && !e.altKey)
      toggleSetting("animation", "toggle");

    // Q - copy (IE) or select text in coordinate box
    else if (key == "Q" && !e.ctrlKey && !e.shiftKey && !e.altKey)
      window.copyCoordinates && window.copyCoordinates();
      
    // SHIFT + Q - reset map settings
    else if (key == 'Q' && e.shiftKey && !e.ctrlKey && !e.altKey)
      mapCookies.resetSettings();
    
    // W - display/hide coordinate box
    else if (key == "W" && !e.ctrlKey)
      toggleSetting("coordinates_box", "toggle");
      
    // U - polygon marker bubble (created here for simplicity)
    else if (key == "U" && !e.ctrlKey)
      toggleSetting("polygon_bubble", "toggle");
      
    // I - invert selection
    else if (key == "I" && !e.ctrlKey && !e.shiftKey && !e.altKey && (!window.polygon || !window.polygon.polygonModeOn))
      invertSelected();
  }
  
  EventUtil.addHandler(document.documentElement, 'keypress', function (e, target)
  {
    if (contains_class(document.body, "lightbox_on"))
      return;
 
    var keyCode = EventUtil.getCharCode(e);
    var key = String.fromCharCode(keyCode).toUpperCase();
    
    //log("keypress: " + key + " - " + keyCode);
    
    // IE doesn't fire keydown while loading map tiles (which is problem for ZM10 and Freemap.sk)
    // - so we process some keys here, other keys still don't work
    if (JAK.Browser.client == "ie")
      processKeys(key, e);     
      
  });

  EventUtil.addHandler(document.documentElement, 'keydown', function (e, target)
  {
    if (contains_class(document.body, "lightbox_on"))
      return;
  
    var key = String.fromCharCode(e.keyCode).toUpperCase();
    //log("keydown: " + key + " - " + e.keyCode);

    // CTRL + Z (+ ALT in polygon mode)  - history back
    if (key == 'Z' && e.ctrlKey && !e.shiftKey 
    && (e.altKey || (!window.polygon || !window.polygon.polygonModeOn)))
    {
      mapHistory.reloadHistory();
      EventUtil.preventDefault(e);
      EventUtil.stopPropagation(e);      
    }
                                           
    // CTRL - display marker bubble
    if (e.ctrlKey && !contains_class(mapadiv, "key_down_ctrl"))
      add_class(mapadiv, "key_down_ctrl");
    
    // ALT  
    else if (e.altKey && !contains_class(mapadiv, "key_down_alt"))
      add_class(mapadiv, "key_down_alt");
      
    // SHIFT
    else if (e.shiftKey && !contains_class(mapadiv, "key_down_shift"))
    {
      add_class(mapadiv, "key_down_shift");
    }

    // spacebar
    else if (e.keyCode == 32)
    {
      if ((!window.polygon || !window.polygon.polygonModeOn) && !window.spacebar_keydown)
      {
        toggleSetting("bubble", "toggle");
        window.spacebar_keydown = true;
      }
    }    
      
    // ESC - close card / remove all selected
    else if (e.keyCode == 27)
    {
      if (document.querySelector(".card"))
      {
        m.removeCard();
        found++;
      }

      else if (!window.polygon || !window.polygon.polygonModeOn)
        removeAllSelections();
    }
    
    // TAB - iterate over points
    // CTRL or SHIFT + TAB iterates over parents only (CTRL doesn't work in Chrome)
    else if (e.keyCode == 9 && (!window.polygon || !window.polygon.polygonModeOn))
    {
      window.lastWPTabIndex = window.lastWPTabIndex || 1;
      var startIndex = window.lastWPTabIndex;
      var found = 0;
      var first = -1;
      var parentsOnly = e.ctrlKey || e.shiftKey;

      for (var point in wp)
      {
        // save first index (to be able to iterate over end)
        if (first == -1 && (!parentsOnly || !wp[point].Parent))
          first = point;
      
        // found? then proceed to the next item
        if (wp[point].id == window.lastWPTabIndex)
          found = 1;
          
        // set center to found point
        else if (found && (!parentsOnly || !wp[point].Parent) && (parseFloat(wp[point].Longitude) || parseFloat(wp[point].Latitude)))
        {
          m.setCenter(new SMap.Coords.fromWGS(wp[point].Latitude, wp[point].Longitude));
          window.lastWPTabIndex = wp[point].id;
          found++;
          break;
        }
      }

      // iterate over end
      if (found == 1 && first != -1)
      {
        if (parseFloat(wp[first].Longitude) || parseFloat(wp[first].Latitude))
          m.setCenter(new SMap.Coords.fromWGS(wp[first].Latitude, wp[first].Longitude));

        window.lastWPTabIndex = wp[first].id;
      }

      EventUtil.preventDefault(e);
      EventUtil.stopPropagation(e);
    }

    // ; - opens map in a browser  
    else if ((e.keyCode == 192 || e.keyCode == 59 /* Firefox */) && (!window.isGeoSetter || e.shiftKey /* v GeoSetteru SHIFT+; */))
    {
      window.open(location.href);
    }
    
    // ENTER - switch between all-screen map and small map  
    else if (e.keyCode == 13 && !e.ctrlKey && !e.shiftKey && !e.altKey)
      allScreenToggle();
      
    // SHIFT + DELETE - delete selected points (upon asking)  
    else if (e.keyCode == 46 && !e.ctrlKey && e.shiftKey && !e.altKey && (!window.polygon || !window.polygon.polygonModeOn))
    {
      deleteSelected();      
    }

    else if (JAK.Browser.client != "ie")
      processKeys(key, e);         
  });

  EventUtil.addHandler(document.documentElement, 'keyup', function (e, target)
  {
    if (contains_class(document.body, "lightbox_on"))
      return;  
  
    var key = String.fromCharCode(e.keyCode).toUpperCase();
    //log("keyup: " + key + " - " + e.keyCode);  

    // CTRL - hide marker bubble
    if (e.keyCode == 17)
      resetCtrlAltShift("ctrl");    
      
    // ALT
    else if (e.keyCode == 18)
      resetCtrlAltShift("alt"); 
      
    // SHIFT
    else if (e.keyCode == 16)
      resetCtrlAltShift("shift");

    // spacebar
    else if (e.keyCode == 32)
    {
      if ((!window.polygon || !window.polygon.polygonModeOn))
      {
        toggleSetting("bubble", "toggle");
        delete window.spacebar_keydown;
      }
    }    
  });
  
  // on window blur and focus, remove any active ALT/CTRL/SHIFT
  EventUtil.addHandler(window, "blur", function(e){resetCtrlAltShift();});
  EventUtil.addHandler(window, "focus", function(e){resetCtrlAltShift();});

  function resetCtrlAltShift(type)
  {
    if (!type || type == "ctrl")
      remove_class(mapadiv, "key_down_ctrl");
    if (!type || type == "alt")
      remove_class(mapadiv, "key_down_alt");
    if (!type || type == "shift")
      remove_class(mapadiv, "key_down_shift");
  }


  //***************************************************************************
  //                ************** Minimap **************
  //***************************************************************************

  // *** create sidebar button ***
  var noprintDiv = document.querySelector(".noprint");
  var minimap_button = JAK.mel("div", {id: "map_minimap_button"}, {cursor: "pointer"});  
  noprintDiv.appendChild(minimap_button);

  // load on start
  if (settings.minimap_on)
  {
    if (!window.contextMenuJSLoaded)
    {
      window.contextMenuJSLoaded = true;
      loadJS(basePath + "context_menu.js", function(){loadJS(basePath + "minimap.js", function(){startMinimap();})});
      loadCSS(basePath + "context_menu.css");
    }
    else
    {  
      loadJS(basePath + "minimap.js", function(){startMinimap();});
    }
    
    loadCSS(basePath + "minimap.css");  
  }
  
  // load JS on hover
  else
  {
    var minimapActivateHandler = EventUtil.addHandler(minimap_button, "mouseover", function(e, target)
    {
      EventUtil.removeHandler(minimapActivateHandler);
      loadJS(basePath + "minimap.js");
      loadCSS(basePath + "minimap.css");
    });
  }
  
  // start on click
  EventUtil.addHandler(minimap_button, "click", function(e, target)
  {
    // wait until minimap and context menu JS files are both loaded
    var int1 = window.setInterval(function()
    {
      if (window.startMinimap && window.contextMenu)    
      {
        startMinimap();
        window.clearInterval(int1);
      }
    }, 0);    
  });
  
  // save settings on minimap exit
  function minimapExitSaveSettings()
  {
    settings.minimap_on = !!window.minimap;
    
    if (!settings.minimap_on)
      return;
  
    settings.minimap_width = window.minimap._options.width;
    settings.minimap_height = window.minimap._options.height;
    settings.minimap_map = window.minimap._options.map;
    
    var zoom = window.minimap._options.zoom;

    if (window.minimap._options.relativeZoom)
      zoom = (window.minimap._options.negativeZoomDif ? "-" : "+") + Math.abs(zoom);
  
    settings.minimap_zoom = zoom;
  }
  
  m.getSignals().addListener(window, "minimap-end", minimapExitSaveSettings);

  //***************************************************************************
  //                ************** Sidebar **************
  //***************************************************************************

  var sidebars_div = document.querySelector("#sidebars");


  // *** create sidebar button ***
  var sidebar_button = JAK.mel("div", {id: "map_sidebar_button", className: "button sidebar_button", innerHTML: tr("Menu")});  
  sidebars_div.appendChild(sidebar_button);
  
  // *** create filter button ***
  var filter_button = JAK.mel("div", {id: "filter_sidebar_button", className: "button sidebar_button", innerHTML: tr("Filter")});  
  sidebars_div.appendChild(filter_button);  

  function initSidebar(e, elm)
  {
    EventUtil.removeHandler(sidebarHandler);
    EventUtil.removeHandler(filterHandler);

    loadJS(basePath + "sidebar.js", function()
    {
      window.sidebarLoader(e, elm); 
    });
    
    loadCSS(basePath + "sidebar.css");
    initFileLoad();
  }
  
  var sidebarHandler = EventUtil.addHandler(sidebar_button, "click", initSidebar);
  var filterHandler = EventUtil.addHandler(filter_button, "click", initSidebar);

  function toggleSetting(setting, type)
  {
    function boolChange(setting) {return ((type == "toggle") ? !setting : ((type == "add") ? 1 : 0));}
    function classChange() {return ((type == "toggle") ? toggle_class : ((type == "add") ? add_class : remove_class));}
    var checkbox = document.getElementById(setting + "_checkbox");

    var newVal;

    if (setting == "animation" || setting == "bubble" || setting == "polygon_bubble"
     || setting == "mark_userflagged_parents" || setting == "mark_userflagged_children")
    {
      classChange()(mapadiv, "marker_" + setting);
      settings["display_" + setting] = boolChange(settings["display_" + setting]);
      newVal = settings["display_" + setting];
    }
    
    else if (setting == "hide_children" || setting == "hide_parents")
    {
      classChange()(mapadiv, "marker_" + setting);
      settings[setting + "_local"] = boolChange(settings[setting + (type == "toggle" ? "_local" : "")]);
      newVal = settings[setting + "_local"];
    }
    
    else if (setting == "circles")
    {
      settings.display_circles = boolChange(settings.display_circles);
      remove_circles();
      settings.display_circles && draw_circles();
      newVal = settings.display_circles;
    }
    
    else if (setting == "spider")
    {
      settings.display_spider = boolChange(settings.display_spider);
      newVal = settings.display_spider;
    }

    else if (setting == "coordinates_box" || setting == "search_field")
    {
      settings["display_" + setting] = boolChange(settings["display_" + setting]);
      newVal = settings["display_" + setting];
          
      var defined = typeof window[setting] !== 'undefined';
      
      if (!defined && newVal && typeof window["load_" + setting] !== 'undefined')
        window["load_" + setting]();
        
      else if (!defined && newVal)
      {
        loadJS(basePath + setting + ".js", function(){window["load_" + setting]();});
        loadCSS(basePath + setting + ".css");
      }
      
      else if (defined)
        // we are using display property elsewhere, so use visibility here
        window[setting].style.visibility = newVal ? "visible" : "hidden";
        
      // if overview map is visible, push it up
      createDefaultMapControls();        
    }
    
    else if (setting == "coordinate_grid" || setting == "coordinate_grid_sjtsk")
    {
      settings["display_" + setting] = boolChange(settings["display_" + setting]);
      newVal = settings["display_" + setting];
          
      var defined = typeof window[setting] !== 'undefined';
      
      if (!defined && newVal && typeof window["load_" + setting] !== 'undefined')
        window["load_" + setting]();
        
      else if (!defined && newVal)
      {
        loadJS(basePath + "coordinate_grid" + ".js", function(){window["load_" + setting]();});
        loadCSS(basePath + "coordinate_grid" + ".css");
      }
      
      else if (defined)
      {
        window["load_" + setting](!newVal);
      }
    }    
    
    else if (setting == "scale")
    {
      settings["display_" + setting] = boolChange(settings["display_" + setting]);
      newVal = settings["display_" + setting];
      
      if (newVal && !window.scaleControl)
      {
        window.scaleControl = new SMap.Control.Scale();
        m.addControl(window.scaleControl, {left: "150px", bottom: "5px"});
      }
      else if (!newVal && window.scaleControl)
      {
        m.removeControl(window.scaleControl);
        window.scaleControl = null;
      }      
    }    

    else if (setting == "overview_map")
    {
      settings["display_" + setting] = boolChange(settings["display_" + setting]);
      newVal = settings["display_" + setting];
      createDefaultMapControls();
    }

    else if (setting == "hide")
    {
      classChange()(mapadiv, "marker_" + setting);
      newVal = contains_class(mapadiv, "marker_" + setting);
      
        // delete original class
      remove_class(mapadiv, "marker_hide_selected");
        // set it only if hide mode is active and any WP is selected
      if (document.querySelectorAll(".wp_selected").length && contains_class(mapadiv, "marker_hide"))
        add_class(mapadiv, "marker_hide_selected");
    }
    
    // private hide markers - hide parking areas, non-found flagged, found non-flagged
    else if (setting == "private_hide")
    {
      classChange()(mapadiv, "marker_" + setting);
      newVal = contains_class(mapadiv, "marker_" + setting);
      
      for (i in wp)
      {
        remove_class(wp[i].marker.getContainer()[SMap.LAYER_MARKER], "marker_private_hidden");
        
        if (!newVal)
          continue;
        
        var parent = wp[i].Parent || i;
          
        if ((wp[i].CacheType == "ParkingArea" && !wp[i].UserFlag) /* non-flagged parking area */
        || (wp[parent].Status2 == "F" && !wp[i].UserFlag && wp[i].Parent && wp[i].CacheType != "ParkingArea") /* non-flagged found */
        || (wp[parent].Status2 != "F" &&  wp[i].UserFlag && wp[i].Parent && wp[i].CacheType != "ParkingArea")) /* flagged non-found */
          add_class(wp[i].marker.getContainer()[SMap.LAYER_MARKER], "marker_private_hidden");
      }

      settings[setting] = newVal;
    }
    
    // hide all non-Final and non-CC members of a family (if there is at least one Final or CC)
    else if (setting == "hide_finals_family")
    {
      classChange()(mapadiv, "marker_" + setting);
      newVal = contains_class(mapadiv, "marker_" + setting);
      
      for (i in wp)
      {
        if (wp[i].Parent)
          continue;
        
        // get entire family and find out if it has Final Location or Corrected Coordinates  
        var codes = get_all_in_family(i);
        var has_final = false;
        
        if (newVal)
        {
          for (var j = 0; j < codes.length; j++)
          {
            if (wp[codes[j]].CacheType == "FinalLocation" || wp[i].HasCorrected)
            {
              has_final = true;
              break;
            }          
          }
        }

        // if it has, hide non-Final/CC
        if (has_final)
        {
          for (var j = 0; j < codes.length; j++)
          {
            if (has_final && wp[codes[j]].CacheType != "FinalLocation" && !wp[codes[j]].HasCorrected)
              add_class(wp[codes[j]].marker.getContainer()[SMap.LAYER_MARKER], "marker_hide_finals_family_hidden");
          }
        }
        
        // otherwise unhide all
        else
        {
          // else clear entire family
          for (var j = 0; j < codes.length; j++)
              remove_class(wp[codes[j]].marker.getContainer()[SMap.LAYER_MARKER], "marker_hide_finals_family_hidden");
        }
      }

      settings[setting] = newVal;    
    }

    // hide archived, disabled, found, owned, other; flagged parents/children, selected
    else if (setting == "hide_status_archived" || setting == "hide_status_disabled" || setting == "hide_status_owned"
      || setting == "hide_status_found" || setting == "hide_status_else"
      || setting == "hide_flagged_parents" || setting == "hide_flagged_children" || setting == "hide_selected")
    {
      classChange()(mapadiv, "marker_" + setting);
      settings[setting] = boolChange(settings[setting]);
      newVal = settings[setting];
    }

    // transparent sub-layers
    else if (setting in transparentLayers)
    {
      var map_id = transparentLayers[setting];

      // turn the layer off first
      m.getLayer(map_id).disable()
      
      var val = settings.transparent_layers[settings.map][setting];

      // is sidebar loaded?
      if (checkbox)
        checkbox.parentNode.style.display = (typeof val === 'undefined') ? "none" : "";
      
      // transparent layer not available in this map
      if (typeof val === 'undefined')
        return;      

      val = boolChange(val);
      settings.transparent_layers[settings.map][setting] = val;

      if (val)
        m.getLayer(map_id).enable();

      newVal = val;
    }
    
    else if (setting == "disable_cache")
    {
      var cachetype = type.getAttribute("data-cachetype");
      remove_class(type, "active");
      add_class(type, "inactive");
      add_class(mapadiv, "disable_cachetype_" + cachetype);
      return;      
    }
    else if (setting == "enable_cache")
    {
      var cachetype = type.getAttribute("data-cachetype");
      remove_class(type, "inactive");
      add_class(type, "active");
      remove_class(mapadiv, "disable_cachetype_" + cachetype);
      return;
    }
    
    else
      throw("Incorrect parameter!");      

    // check/uncheck sidebar checkbox
    if (checkbox)
      checkbox.checked = newVal;
  }
  
  //***************************************************************************
  //                ************** Polygon **************
  //***************************************************************************
  
  // *** create sidebar button ***
  var polygon_button = JAK.mel("div", {id: "polygon_sidebar_button", className: "button sidebar_button", innerHTML: tr("Track")});  
  sidebars_div.appendChild(polygon_button);

  var polygonHandler = EventUtil.addHandler(polygon_button, "mouseover", function()
  {
    initFileLoad(function()
    {
      loadJS(basePath + "polygon.js");
      loadCSS(basePath + "polygon.css");
      EventUtil.removeHandler(polygonHandler);
    });
  });
  
  //***************************************************************************
  //                ************** Selections **************
  //***************************************************************************
  var drawSelectionLayer;
  var selectionType;
  var selectionMode;
  var selectionColor;
  var selectionPolygon = [];
  var selectionId;
  window.selectedCaches = [];
  window.selectionControls = [];

  var onPolygonSelectionStart = function(e, target, selection)
  {
    selectionId = this.customId;

    selectionPolygon = [];
    drawSelectionLayer = new SMap.Layer.Geometry("drawSelectionLayer");
    m.addLayer(drawSelectionLayer);
    drawSelectionLayer.enable();

    selectionType = this.customId.match(/(^.*?)_/)[1]; /* Rectangle, Polygon */
    selectionMode = this.customId.replace(/^.*_/, "");

    var colors = {"AddToSelection": "green", "Select": "yellow", "DeSelect": "red", "SelectXOR": "#FFA500" /* orange: IE7-8 fix */}
    selectionColor = colors[selectionMode];    
  }
  
  var onPolygonSelection = function(e)
  {
    if (this.customId != selectionId)
      return;

    // draw polygon
    if (selectionType == "Polygon")
    {
      selectionPolygon.push(this._point2.clone().toCoords(m));
    }
    
    // draw rectangle
    else if (selectionType == "Rectangle")
    {
      this._backupRedraw();
      this._dom.container.style.background = selectionColor;
      
      selectionPolygon = [];
      var p1 = this._point1.clone();
      var p2 = this._point2.clone();
      var p3 = new SMap.Pixel(p2.x, p1.y);
      var p4 = new SMap.Pixel(p1.x, p2.y);
      selectionPolygon.push(p1.toCoords(m));
      selectionPolygon.push(p4.toCoords(m));
      selectionPolygon.push(p2.toCoords(m));
      selectionPolygon.push(p3.toCoords(m));
    }

    if (selectionType != "Rectangle")
    {
      drawSelectionLayer.removeAll();
      var options = {color: selectionColor, outlineWidth: 4, outlineColor: "blue", outlineOpacity: 0.3, opacity: 0.3}; 
      var selPol = new SMap.Geometry(SMap.GEOMETRY_POLYGON, null, selectionPolygon, options);
      drawSelectionLayer.addGeometry(selPol);
    }
  }
  
  var onPolygonSelectionStop = function(e)
  {
    _decideSelection(selectionMode, selectionPolygon);
    onPolygonSelectionStopFail(e);
  }
  
  var onPolygonSelectionStopFail = function(e)
  {
    selectionId = null;
    drawSelectionLayer.removeAll();  
    m.removeLayer(drawSelectionLayer);
  }
  
  var _decideSelection = function(mode, points)
  {
    var oldSelected = selectedCaches.clone();

    // AddToSelection: add all points in range to existing selection
    // Deselect: remove all points in range from existing selection
    // Select: replace any previous selection with points withing range
    // SelectXOR: intersection of previous selection and points within range
    for (var i in wp)
    {
      var point = wp[i].marker.getCoords();
      var display = window.getComputedStyle(wp[i].marker.getContainer()[SMap.LAYER_MARKER]).getPropertyValue("display") == "none";
      var isIn = point.inMap(m) && point.inPolygon(m, points) && !display;
      var isSelected = selectedCaches.indexOf(i) != -1;
      
      if (isIn)
      {
        if (mode == "Select" && !isSelected)
          selectedCaches.push(i);      
        else if (mode == "AddToSelection" && !isSelected)
          selectedCaches.push(i);
        else if (mode == "DeSelect" && isSelected)
          selectedCaches.remove(selectedCaches.indexOf(i));
      }
      else
      {
        if (isSelected && (mode == "Select" || mode == "SelectXOR"))
          selectedCaches.remove(selectedCaches.indexOf(i));
      }
    }

    // check if anything changed - if not, then remove last history entry (which was added above)
    var popHistory = selectedCaches.compare(oldSelected);

    synchronizeSelected();
    
    if (!popHistory && mapHistory)
      mapHistory.saveHistory();
  }
  
  // synchronize selected list with wp list
  function synchronizeSelected()
  {
    // remove non-existent
    var newSelected = [];
    
    for (var i = 0; i < window.selectedCaches.length; i++)
    {
      if (wp[window.selectedCaches[i]])
        newSelected.push(window.selectedCaches[i]);
    }

    window.selectedCaches = newSelected;
  
    // set marker class
    for (var i in wp)
      remove_class(wp[i].marker.getContainer()[SMap.LAYER_MARKER], "marker_draw_selected");
  
    for (var i = 0; i < selectedCaches.length; i++)
    {
      add_class(wp[selectedCaches[i]].marker.getContainer()[SMap.LAYER_MARKER], "marker_draw_selected");
    }  
  }
  
  function deleteSelected()
  {
    for (var i = 0; i < window.selectedCaches.length; i++)
    {
      var child = window.selectedCaches[i];
      
      if (!wp[child])
        continue;
      
      var parent = wp[child].Parent || child;    
    
      delete_waypoint((child == parent || wp[child].CacheType == "Corrected") ? get_all_in_family(parent) : child);
    }
  
    synchronizeSelected();
    
//     if (window.selectedCaches && window.selectedCaches.length)
//     {
//       mapHistory.removeLast();
//       mapHistory.saveHistory();
//     }
  }
  
  function invertSelected()
  {
    var newSelected = [];
    
    for (var i in wp)
    {
      if (selectedCaches.indexOf(i) == -1)
        newSelected.push(i);
    }

    selectedCaches = newSelected;  
  
    synchronizeSelected();
    mapHistory.saveHistory();
  }
  
  function removeAllSelections()
  {
    var ret = selectedCaches.length;
  
    selectedCaches = [];  
    synchronizeSelected();
    
    if (ret)
      mapHistory.saveHistory();
          
    return ret;
  }  

  /* computes whether a point is within polygon */
  // info: http://alienryderflex.com/polygon/
  function pointInPolygon(polygon, point) 
  {
    return point.inPolygon(m, polygon);
  }

  /**** select points ****/
  function selectionsInit()
  {
    var selOptionsDefault = {customHandler: onPolygonSelectionStop, customFailDrag: onPolygonSelectionStopFail,
      customRedraw: onPolygonSelection, customStartDrag: onPolygonSelectionStart, thickness: 4};
  
    var selControls = [];
    
    selControls.push({mouseButton: JAK.Browser.mouse.left, shift: true, alt: true, cursor: "cell", customId: "Rectangle_AddToSelection"});
    selControls.push({mouseButton: JAK.Browser.mouse.left, shift: true, cursor: "cell", customId: "Rectangle_Select"});
    selControls.push({mouseButton: JAK.Browser.mouse.left, alt: true, customId: "Rectangle_DeSelect"});  
    selControls.push({mouseButton: JAK.Browser.mouse.left, shift: true, alt: true, ctrl: true, customId: "Rectangle_SelectXOR"});
  
    selControls.push({mouseButton: JAK.Browser.mouse.right, shift: true, alt: true, cursor: "cell", customId: "Polygon_AddToSelection"});
    selControls.push({mouseButton: JAK.Browser.mouse.right, shift: true, cursor: "cell", customId: "Polygon_Select"});
    selControls.push({mouseButton: JAK.Browser.mouse.right, alt: true, customId: "Polygon_DeSelect"});  
    selControls.push({mouseButton: JAK.Browser.mouse.right, shift: true, alt: true, ctrl: true, customId: "Polygon_SelectXOR"});
        
    for (var i = 0; i < selControls.length; i++)
    {
      SMap.Util.mergeObject(selOptionsDefault, selControls[i]);
      var control = new SMap.Control.Selection(selControls[i]);
      window.selectionControls.push(control);
      m.addControl(control);  
    }
  }
  
  function selectionsExit()
  {
    while (window.selectionControls && window.selectionControls.length)
    {
      var control = window.selectionControls.pop();
      
      // destructor doesn't get called for some reason, so call it manually
      //control.$destructor(); /* turned off 2014-8-23, I hope it was fixed */
      m.removeControl(control);
    }  
  }
  
  selectionsInit();
  
  // turn off while polygon mode is active
  m.getSignals().addListener(window, "polygon-mode-init", function(e, elm) {selectionsExit();});  
  m.getSignals().addListener(window, "polygon-mode-exit", function(e, elm) {selectionsInit();});  
  
  //***************************************************************************
  //                ************** Misc **************
  //***************************************************************************  
  
//   // hide mapy.cz logo
//   document.querySelector(".noprint").removeChild(document.querySelector(".noprint > img"));
//   document.querySelector(".noprint").removeChild(document.querySelector(".copyright"));

 // document.getElementById("map_sidebar")

 
// function copy_to_clipboard(text)  
// {  
// //   if(window.clipboardData)  
// //     window.clipboardData.setData('text',text);  
// //  
// //   else
//   {          
//     var clipboarddiv = document.getElementById('divclipboardswf');
//       
//     if(clipboarddiv == null)  
//     {  
//       clipboarddiv=document.createElement('div');
//       clipboarddiv.setAttribute("name", "divclipboardswf");
//       clipboarddiv.setAttribute("id", "divclipboardswf");
//       document.body.appendChild(clipboarddiv);
//     }
//       
//     clipboarddiv.innerHTML='<embed src=basePath + "clipboard.swf" FlashVars="clipboard=' +
//     encodeURIComponent(text) + '" width="0" height="0" type="application/x-shockwave-flash"></embed>';
//   }
//   
//   //alert('The text is copied to your clipboard...');  
//   return false;     
// }                         
//                                        

  //copy_to_clipboard("ddd");    
//   loadJS(basePath + "ZeroClipboard/ZeroClipboard.js");
//   
//   setTimeout(function(){
//   	clip = new ZeroClipboard.Client();
//   	clip.setText("xxx");
//     log("done");         
//   }, 2000);

     //window.location.href = "gsak://%FF/macro:silent/HTML_Custom_MapyCZ\\Update_Database.gsk?" + "aaaa" + "###" + Code + "/" + parent;

// *************  
//     var runs = 10;
//     var num = parseInt(read_cookie('timer_int')) || 0;
//     
//     if (!num)
//     {
//       write_cookie('timer_total', new Date().getTime());
//     }
//     
//     write_cookie('timer_int', num + 1);
//     log(num + 1);
//     
//     if (num >= 10)
//     {
//       var old_time = read_cookie('timer_total');
//       log("average: " + (new Date().getTime() - old_time) / (1000 * num));
//       clear_cookie('timer_int');
//     }
//     else
//     {
//       window.setTimeout(function(){window.location.href = "gsak://%FF/refreshbrowser";}, 1000 /* prevents GSAK error */);
//     }
    
// *************
    
  //***********************************
  // *** translate all strings ***
  function translate_strings(selector)
  {
    var nodes = document.querySelectorAll(selector || "*[data-tr]");

    // IE7 adds extra space to the end of LI elements, so remove it
    if (JAK.Browser.client == "ie" && JAK.Browser.version <= 7)
    {
      for (var i = 0, len = nodes.length; i < len; i++)
      {
        if (nodes[i].tagName.toLowerCase() == "li" && nodes[i].innerHTML.charAt(nodes[i].innerHTML.length-1) == " ")
          nodes[i].innerHTML = nodes[i].innerHTML.slice(0, -1);        
      }     
    }
    
    // translate
    for (var i = 0, len = nodes.length; i < len; i++)
    {
      nodes[i].innerHTML = tr(nodes[i].innerHTML);
      nodes[i].removeAttribute("data-tr");
    }  
  }
   
//   window.setTimeout(function()
//   {
//     translate_strings();
//   }, 0);
  
  //alert(window.top.document.body.className);
  

  /*** measure time - end (loading the map) ***/
  var old_time = read_cookie('timer');
  old_time && log("Total: " + (new Date().getTime() - old_time) / 1000);
  
  

//   /** Web Timing API **/
//   // http://webtimingdemo.appspot.com/
//   
//   // Retrieve the performance object in a cross browser way. It is important to check window.performance first.
//   window.performance = window.performance || window.mozPerformance || window.msPerformance || window.webkitPerformance || {};
//   var timing = performance.timing;
//   
//   if (timing)
//   {
//     //log_object(window.performance.timing);
//     var ieOld = JAK.Browser.client == "ie" && JAK.Browser.version <= 8;
//     
//     function logJSLoad()
//     {
//       log("JS: " + (new Date().getTime() - (ieOld ? timing.loadEventEnd : timing.domContentLoadedEventEnd)) / 1000 + " s");
//     }
//     
//     function logPageLoad()
//     {
//       log("Page: " + (timing.loadEventEnd - timing.navigationStart) / 1000 + " s");
//     }    
// 
//     // waint until page is loaded
//     var timingInt = window.setInterval(function()
//     {
//       if (timing.loadEventEnd)
//       {
//         logPageLoad()
//         ieOld && logJSLoad();
//         window.clearInterval(timingInt);
//       }
//     }, 100)
//     
//     !ieOld && logJSLoad();
//   }


  //**********
  
//   // this fixes GSAK error when going from cache to cache too quickly (we detect if SplitScreen exists - OK, or not - BAD)
//   window.setTimeout(function()
//   {
//     if (navigator.appName == 'Microsoft Internet Explorer' && /SplitScreen\.htm$/.test(window.location))
//     {
//       try
//       {
//         var xhr = new ActiveXObject("MSXML2.XMLHTTP");
//         
//         xhr.onreadystatechange = function(e)
//         {
//           if (xhr.readyState == 4 && xhr.status == 2)
//             window.location.href = "gsak://%FF/macro:silent/HTML_Custom_MapyCZ.gsk";
//         }
// 
//         xhr.open("get", "SplitScreen.htm", false);
//         xhr.send(null);
//       }
//       catch(ex){}    
//     }
//   }, 500);

// log(document.documentElement.scrollHeight);
// log(document.documentElement.clientHeight);
// log(document.documentElement.offsetHeight);
// log(document.documentElement.scrollHeight > document.documentElement.clientHeight);


// var val = 15.0100;
// var places = 7;
// 
// val = val.toFixed(places);
// val = /\./.test(val) ? (val.replace(/\.?[0]+$/, "")) : val;
// 
// log(val);

// timer_start("coords");
// var p = new SMap.Coords.fromWGS(50.3534534, 15.234324234);
// // 
// // var text = "50.43534534";
// 
// var exp = [];
// 
//   var latlon = [p.lon(), p.lat()];
//                  
//   
// 
// 
// for (var i = 0; i < 10000; i++)
// {
//   var exp = [];
//   
//   var y = latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + latlon[1].toFixed(6) + ", " + ",";
// 
//   //var x = exp.join(", ");
// }
// 
// timer_end("coords");
// 
// 



//************************************
// fix Opera issues

// prevent Opera CTRL+click on map to save image
if (JAK.Browser.client == "opera")
{
  EventUtil.addHandler(document.documentElement, "click", function (e)
  {
    if (e.ctrlKey)
      EventUtil.preventDefault(e);
  }, true);
}

// prevent CTRL (+ SHIFT) + click on SVG 
if (JAK.Browser.client == "opera")
{
  // create div that will cover the screen
  var overlay = JAK.mel("div");
  var length = 1e8;
  overlay.style.width = length + "px";
  overlay.style.height = length + "px";
  overlay.style.position = "absolute";
  overlay.style.left = -length / 2 + "px";
  overlay.style.top = -length / 2 + "px";
  overlay.style.background = "red";
  overlay.style.opacity = "0.0";
  
  // place svg to a new div and put cover div after it
  var svg = document.querySelectorAll("#mapadiv svg")[0];
  var elm = JAK.mel("div");
  svg.parentNode.insertBefore(elm, svg.parentNode.childNodes[1]);
  elm.appendChild(svg);
  elm.appendChild(overlay);
  
  // turn layer off on pressing ALT
  EventUtil.addHandler(document.documentElement, "keydown", function(e)
  {
    if (e.altKey)
      overlay.style.display = "none";
  }, true);
  
  function showOverlay()
  {
    overlay.style.display = "";
  }
  
  // on keyup enable overlay again
  EventUtil.addHandler(document.documentElement, "keyup", showOverlay, true);
  
  // on leaving and entering the map, enable overlay as well
  EventUtil.addMouseHandler(mapadiv, "mouseenter", showOverlay);
  EventUtil.addMouseHandler(mapadiv, "mouseleave", showOverlay);
}

// *******************
// go allscreen and back

// *** add button ***
if (window.gsakTwoColumnsMode)
{
  var noprintDiv = document.querySelector(".noprint");
  var allScreen_button = JAK.mel("div", {id: "allScreen_button"}, {cursor: "pointer"});  
  noprintDiv.appendChild(allScreen_button);
  
  EventUtil.addHandler(allScreen_button, "click", allScreenToggle);
}

function allScreenToggle()
{
  if (!window.gsakTwoColumnsMode)
    return;

  // to all screen
  if (!contains_class(document.documentElement, "mapFull"))
    allScreen()
  
  // to normal
  else
    endAllScreen()
}

window.savedMapHeight = mapadiv.style.height;

function allScreen()
{
  if (window.gsakTwoColumnsMode)     /* for CSS */
    remove_class(document.body, "gsakTwoColumnsMode");

  document.body.appendChild(mapadiv);
  
  var cMenu = document.getElementById("contextMenu");
  var cMenuWP = document.getElementById("contextMenuWP");
  
  if (cMenu) document.body.appendChild(cMenu);
  if (cMenuWP) document.body.appendChild(cMenuWP);
 
  add_class(document.documentElement, "mapFull");
  mapadiv.style.height = document.documentElement.clientHeight + "px";

  if (window.svObjekt)          /* Street View */
    svObjekt.syncViewPort();
  
  if (window.polygon)
    window.polygon.textArea.syncViewPort();
  
  m.syncPort();
  createDefaultMapControls();   
}

function endAllScreen()
{
  if (window.gsakTwoColumnsMode)     /* for CSS */
    add_class(document.body, "gsakTwoColumnsMode");
       
  var rightCol = document.getElementById("main_right_col");
  rightCol.insertBefore(mapadiv, rightCol.firstChild);
  remove_class(document.documentElement, "mapFull");
  mapadiv.style.height = window.savedMapHeight;

  if (window.svObjekt)
    svObjekt.syncViewPort();

  if (window.polygon)
    window.polygon.textArea.syncViewPort();
          
  m.syncPort();
  createDefaultMapControls();     
}

// fix some sidebar buttons on window resize
EventUtil.addHandler(window, "resize", function()
{
  if (!contains_class(document.documentElement, "mapFull"))
    return;

  mapadiv.style.height = document.documentElement.clientHeight + "px";
});

//**********


//--------------------------------------------------------------

  // bug, kde se při zjišťování výšky okna v konstruktoru mapy pomocí clientHeight vrátí 0
  // -- nastává v Chromu a ve Firefoxu po nějaké době nečinnosti prohlížeči, kdy se při načtení stránky asi pomalu aktualizuje DOM
  // -- mapa pak je proužek na vrchu obrazovky
  // -- po opravě níže zůstane nesprávný zoom, takže se mapa zobrazí třeba přes celou Evropu místa jen předmětného kraje
  // -- ideálně by bylo třeba nějak zajistit, aby před vytvořením new SMap byl DOM načtený 

  if (!m.getSize().y)
  {
    window.setTimeout(function()
    {
      m.syncPort();
      setCenterZoomFromCaches();
    }, 0);  
  }

//--------------------------------------------------------------
// detekce embedded
//   function parseobject(obj)
//   {
//     var ret = "";
//     
//     if (typeof obj !== 'object')
//       return (obj + "\n");
// 
//     for (var prop in obj)
//     {
//       try
//       {
//         if (typeof obj[prop] === 'function')
//           ret += prop + ": (function)\n";
//         else
//           ret += prop + ": " + obj[prop] + "\n";
//       }
//       catch(ex)
//       {
//         ret += "<span style='color: red'>" + prop + ": reading property failed!</span>" + "\n";
//       }      
//     }
// 
//     return ret;   
//   }
// 
//   ui("copybox", {text: function()
//   {
//     var ret = "";
//     ret += parseobject(window.navigator);
//     ret += parseobject(window.defaultStatus);
//     ret += parseobject(window.document);
//     ret += parseobject(window.history);
//     ret += parseobject(window.location);
//     ret += parseobject(window.name);
//     ret += parseobject(window.status);
//     ret += parseobject(window.parent);
//     ret += parseobject(window.opener);
//     ret += parseobject(window);
//     
//     return ret;
// 
//   }(), width: 600, height: 400, select: true});

