// info: might use proj4js library in the future (can convert between projections)

/* custom map definitions */
var default_preview_path = "../../../Images/Maps/";

SMap.CONFIG.bBox_CZ = {latMin: 48, latMax: 52, lonMin: 11, lonMax: 20};
SMap.CONFIG.bBox_MapyCZ = {latMin: 38, latMax: 57, lonMin: 5, lonMax: 25};
SMap.CONFIG.bBox_Mercator = {latMin: -75, latMax: 85, lonMin: -SMap.Coords.maxLon, lonMax: SMap.Coords.maxLon};

SMap.CONFIG["ZM10_ID"] = 
{
  zoom: [3, 18],
  label: "ZM10",
  title: "Základní mapa 10k",
  preview: default_preview_path + "ZM10.jpg",
  url: "",
  options: {prefetch: 0, tileSize: 256, gcDelay: (1000 * 3600 * 1)},
  copyright: {"1-": "ČÚZK"},
  projection: SMap.projMercator,

  buildUrl: function(t /*tile*/)
  {
    if      (t.zoom >= 13) var mapType = "GR_ZM10";
    else if (t.zoom >= 11) var mapType = "GR_ZM50";
    else if (t.zoom >= 9)  var mapType = "GR_MCR500";
    else if (t.zoom >= 0)  var mapType = "GR_CR4";
    
    if      (t.zoom >= 13) var mapDir = "WMS_ZM10_PUB";
    else if (t.zoom >= 11) var mapDir = "WMS_ZM50_PUB";
    else if (t.zoom >= 0)  var mapDir = "WMS_PREHLEDKY";

    // http://geoportal-zm3.cuzk.cz/WMS_ZM10_PUB/service.svc/get?SERVICE=WMS&REQUEST=GetMap&VERSION=1.3.0&LAYERS=GR_ZM10&FORMAT=image%2Fpng8&WIDTH=256&HEIGHT=256&BBOX=458208,5548320,458464,5548576&CRS=EPSG%3A32633&STYLES=&TRANSPARENT=TRUE
    return ("http://geoportal-zm" + Math.floor(Math.random() * 4) + ".cuzk.cz" + "/" + mapDir + "/service.svc/get?"
      + "SERVICE=WMS&REQUEST=GetMap&VERSION=1.3.0" + "&LAYERS=" + mapType + "&FORMAT=" + encodeURIComponent("image/png8") 
      + "&WIDTH=" + t.tileSize + "&HEIGHT=" + t.tileSize + "&BBOX=" + t.getBBOX(this.getMap()) 
      + "&CRS=" + encodeURIComponent(this.getMap().getProjection().getCode()) + "&STYLES=&TRANSPARENT=FALSE");  
  },
  bBox: SMap.CONFIG.bBox_CZ 
};
 
// http://mapy.vugtk.cz/mapserver/index_wms.php
SMap.CONFIG["Muller_ID"] = 
{
  zoom: [10, 15],
  label: "Müllerova mapa",
  title: "Müllerova mapa Čech a Moravy (1720)",
  preview: default_preview_path + "Mullerova mapa.png",
  url: "",
  options: {prefetch: 0, tileSize: 512},
  copyright: {"1-": "VÚGTK"},
  
  // nepoužívá ve skutečnosti ArcGIS, použit trik aby fungovalo S-JTSK
  projection: new SMap.Projection.ArcGIS(
  {
    "rows": 512,
    "cols": 512,
    "dpi": 96,
    "format": "JPEG",
    "compressionQuality": 55,
    "origin": {"x": -33699800, "y": 33699800},
    "spatialReference": {"wkid": 102067},
    "lods":
    {
      "0": {"resolution": 128.01625603251208, "scale": 483840},
      "1": {"resolution": 64.00812801625604, "scale": 241920},
      "2": {"resolution": 32.00406400812802, "scale": 120960},
      "3": {"resolution": 16.00203200406401, "scale": 60480},
      "4": {"resolution": 8.001016002032005, "scale": 30240},
      "5": {"resolution": 4.000508001016002, "scale": 15120},
      //"6": {"resolution": 2.000254000508001, "scale": 7560},
    }
  },
  {
    "xmin": -1966019.01672004,
    "ymin": -1828752.51746725,
    "xmax": 723602.115135592,
    "ymax": -278689.121977079,
    "spatialReference": {"wkid": 102067}
  }, 10),

  buildUrl: function(t /*tile*/)
  {
    return ("http://mapy.vugtk.cz/cgi-bin/mapserv?bbox=" + t.getBBOX(this.getMap()) 
    + "&width=" + t.tileSize + "&height=" + t.tileSize + "&map=/var/www/map_data/wms.map&srs=" 
    + encodeURIComponent("epsg:2065") + "&request=GetMap&version=1.1.1&layers=muller,mullermorava&format=" 
    + encodeURIComponent("image/jpeg") + "&styles=");      
       
  },
  bBox: SMap.CONFIG.bBox_CZ 
};

SMap.CONFIG["Orto_CZ_ID"] = 
{
  zoom: [7, 19],
  label: "Ortofoto ČR",
  title: "Ortofoto ČR",
  preview: default_preview_path + "Orto_CZ.png",
  url: "",
  options: {prefetch: 0, tileSize: 256},
  buildUrl: function(t /*tile*/)
  {
    return "http://ags.cuzk.cz/ArcGIS/rest/services/ortofoto/MapServer/tile/" + (t.zoom - 7) + "/" + t.y + "/" + t.x;
  },

  copyright: {"1-": "Podkladová data ČÚZK"},
  projection: new SMap.Projection.ArcGIS(
  {
    "rows": 256,
    "cols": 256,
    "dpi": 96,
    "format": "JPEG",
    "compressionQuality": 55,
    "origin": {"x": -33699800, "y": 33699800},
    "spatialReference": {"wkid": 102067},
    "lods":
    {
      "0": {"resolution": 1024.1300482600966, "scale": 3870720},
      "1": {"resolution": 512.0650241300483, "scale": 1935360},
      "2": {"resolution": 256.03251206502415, "scale": 967680},
      "3": {"resolution": 128.01625603251208, "scale": 483840},
      "4": {"resolution": 64.00812801625604, "scale": 241920},
      "5": {"resolution": 32.00406400812802, "scale": 120960},
      "6": {"resolution": 16.00203200406401, "scale": 60480},
      "7": {"resolution": 8.001016002032005, "scale": 30240},
      "8": {"resolution": 4.000508001016002, "scale": 15120},
      "9": {"resolution": 2.000254000508001, "scale": 7560},
      "10": {"resolution": 1.0001270002540006, "scale": 3780},
      "11": {"resolution": 0.5000635001270003, "scale": 1890},
      "12": {"resolution": 0.25003175006350015, "scale": 945}
    }
  },
  {
    "xmin": -1966019.01672004,
    "ymin": -1828752.51746725,
    "xmax": 723602.115135592,
    "ymax": -278689.121977079,
    "spatialReference": {"wkid": 102067}
  }, 7),
  bBox: SMap.CONFIG.bBox_CZ 
};

// http://ags.cuzk.cz/ArcGIS/rest/services/zm/MapServer
// JS: http://ags.cuzk.cz/ArcGIS/rest/services/zm/MapServer?f=json
SMap.CONFIG["ZM10_SJTSK_ID"] = 
{
  zoom: [8, 18],
  label: "ZM10  Turbo",
  title: "Základní mapa 10k (S-JTSK verze - rychlejší)",
  preview: default_preview_path + "ZM10.jpg",
  options: {prefetch: 0, tileSize: 256/*, defaultProjection: SMap.projUTM33*/},
  buildUrl: function(t /*tile*/)
  {
    return "http://ags.cuzk.cz/ArcGIS/rest/services/zm/MapServer/tile/" + (t.zoom - 8) + "/" + t.y + "/" + t.x;
  },

  copyright: {"1-": "Podkladová data ČÚZK"},
  projection: new SMap.Projection.ArcGIS(
  {
    "rows": 256,
    "cols": 256,
    "dpi": 96,
    "format": "JPEG",
    "compressionQuality": 90,
    "origin": {"x": -33699800, "y": 33699800},
    "spatialReference": {"wkid": 102067},
    "lods":
    {
      "0": {"resolution": 1024.1300482601, "scale": 3870720},
      "1": {"resolution": 512.065024130048, "scale": 1935360},
      "2": {"resolution": 256.032512065024, "scale": 967680},
      "3": {"resolution": 128.016256032512, "scale": 483840},
      "4": {"resolution": 64.008128016256, "scale": 241920},
      "5": {"resolution": 32.004064008128, "scale": 120960},
      "6": {"resolution": 16.002032004064, "scale": 60480},
      "7": {"resolution": 8.001016002032, "scale": 30240},
      "8": {"resolution": 4.000508001016, "scale": 15120},
      "9": {"resolution": 2.000254000508, "scale": 7560},
      "10": {"resolution": 1.000127000254, "scale": 3780}
    }
  },
  {
    "xmin": -1966019.01672004,
    "ymin": -1828752.51746725,
    "xmax": 723602.115135592,
    "ymax": -278689.121977079,
    "spatialReference": {"wkid": 102067}
  }, 8),
  bBox: SMap.CONFIG.bBox_CZ 
};

// http://geoportal.gov.cz/web/guest/wms/
// http://geoportal.gov.cz/arcgis/rest/services/CENIA/cenia_rt_III_vojenske_mapovani/MapServer
SMap.CONFIG["VojMapIII_ID"] = 
{
  zoom: [5, 14],
  label: "III. voj. mapování",
  title: "III. vojenské mapování (1876-1878)",
  preview: default_preview_path + "III. vojenske mapovani.png",
  url: "",
  options: {prefetch: 0, tileSize: 512, gcDelay: (1000 * 3600 * 1)},
  projection: SMap.projUTM33,

  buildUrl: function(t /*tile*/)
  {
    return ("http://geoportal.gov.cz/ArcGIS/services/CENIA/cenia_rt_III_vojenske_mapovani/MapServer/WMSServer?"
      + "BBOX=" + t.getBBOX(this.getMap()) + "&WIDTH=" + t.tileSize + "&HEIGHT=" + t.tileSize
      + "&CRS=" + encodeURIComponent(this.getMap().getProjection().getCode())
      + "&Layers=0&version=1.3.0&service=WMS&format=" + encodeURIComponent("image/png8") + "&request=GetMap&styles=");
  },
	copyright: 
  {
		"-": ["3rd Military Survey, Austrian State Archive", "Datový podklad MŽP ČR", "Laboratoř geoinformatiky UJEP"]
	},
  bBox: SMap.CONFIG.bBox_CZ  
};

SMap.CONFIG["Vojenska_ID"] = 
{
  zoom: [6, 18],
  label: "Vojenská mapa",
  title: "Vojenská mapa",
  preview: default_preview_path + "Vojenska mapa.png",
  url: "",
  options: {prefetch: 0, tileSize: 256, gcDelay: (1000 * 3600 * 1)},
  copyright: {"1-": "GeoPortal.gov / ČÚZK"},
  
  buildUrl: function(t /*tile*/)
  {
    return "http://geoportal.gov.cz/ArcGIS/rest/services/CENIA/cenia_rt_RETM/MapServer/tile/" + (t.zoom - 6) + "/" + t.y + "/" + t.x;
  },

  copyright: {"1-": "Cenia"},
  projection: new SMap.Projection.ArcGIS(
  {
    "rows": 256,
    "cols": 256,
    "dpi": 96,
    "format": "JPEG",
    "compressionQuality": 75,
    "origin": {"x": -920000.0, "y": -920000.0},
    "spatialReference": {"wkid": 102067},
    "lods":
    {
      "0": {"resolution": 2048.260096520193, "scale": 7741440},
      "1": {"resolution": 1024.1300482600966, "scale": 3870720},
      "2": {"resolution": 512.0650241300483, "scale": 1935360},
      "3": {"resolution": 256.03251206502415, "scale": 967680},
      "4": {"resolution": 128.01625603251208, "scale": 483840},
      "5": {"resolution": 64.00812801625604, "scale": 241920},
      "6": {"resolution": 32.00406400812802, "scale": 120960},
      "7": {"resolution": 16.00203200406401, "scale": 60480},
      "8": {"resolution": 8.001016002032005, "scale": 30240},
      "9": {"resolution": 4.000508001016002, "scale": 15120},
      "10": {"resolution": 2.000254000508001, "scale": 7560},
      "11": {"resolution": 1.0001270002540006, "scale": 3780},
      "12": {"resolution": 0.5000635001270003, "scale": 1890}
    }
  },
  {
    "xmin": -975345.6758081501,
    "ymin": -1283724.921699355,
    "xmax": -384561.6758081501,
    "ymax": -865996.921699355,
    "spatialReference": {"wkid": 102067}
  }, 6),
  bBox: SMap.CONFIG.bBox_CZ
//   projection: SMap.projUTM33,
// 
//   buildUrl: function(t /*tile*/)
//   {
//     return ("http://geoportal.gov.cz/ArcGIS/services/CENIA/cenia_rt_RETM/MapServer/WMSServer?"
//       + "BBOX=" + t.getBBOX(this.getMap()) + "&WIDTH=" + t.tileSize + "&HEIGHT=" + t.tileSize
//       + "&CRS=" + encodeURIComponent(this.getMap().getProjection().getCode())
//       + "&Layers=0&version=1.3.0&service=WMS&format=" + encodeURIComponent("image/png8") + "&request=GetMap&styles=");
//   }
};

SMap.CONFIG["IZS_ID"] = 
{
// http://giscr.hzspk.cz/arcgis/rest/services/giscr/MapServer/tile/1/256/243
// http://giscr.hzspk.cz/arcgis/rest/services/giscr/MapServer/tile/0/128/121
 
  zoom: [8, 17],
  label: "IZS",
  title: "Mapa IZS",
  preview: default_preview_path + "IZS.png",
  options: {prefetch: 0, tileSize: 512, gcDelay: (1000 * 3600 * 1)},
  buildUrl: function(t /*tile*/)
  {
    return "http://giscr.hzspk.cz/arcgis/rest/services/giscr/MapServer/tile/" + (t.zoom - 8) + "/" + t.y + "/" + t.x;
  },

  copyright: {"1-": ["HZS ČR (giscr.hzspk.cz)", "ČÚZK", "OpenStreetMap"]},
  projection: new SMap.Projection.ArcGIS(
  {
    "rows": 512,
    "cols": 512,
    "dpi": 96,
    "format": "JPEG",
    "compressionQuality": 92,
    "origin": {"x": -3.36998E7, "y": 3.36998E7},
    "spatialReference": {"wkid": 102067},
    "lods":
    {
      "0": {"resolution": 529.167725002117, "scale": 2000000.0},
      "1": {"resolution": 264.583862501058, "scale": 1000000.0},
      "2": {"resolution": 132.291931250529, "scale": 500000.0},
      "3": {"resolution": 52.9167725002117, "scale": 200000.0},
      "4": {"resolution": 26.4583862501058, "scale": 100000.0},
      "5": {"resolution": 13.2291931250529, "scale": 50000.0},
      "6": {"resolution": 5.29167725002117, "scale": 20000.0},
      "7": {"resolution": 2.64583862501058, "scale": 10000.0},
      "8": {"resolution": 1.32291931250529, "scale": 5000.0},
      "9": {"resolution": 0.529167725002117, "scale": 2000.0}
    }
  },
  {
    "xmin": -3492095.358275245,
    "ymin": -3230781.3606962427,
    "xmax": 2407504.3466071645,
    "ymax": 1854772.3786539468,
    "spatialReference": {"wkid": 102067}
  }, 8),
  bBox: {latMin: 46, latMax: 55, lonMin: 6, lonMax: 24}
};

// Mapy.cz DEF_OPHOTO - transparent sub-layer version
SMap.CONFIG["MapyCZ_OPHOTO_Sub"] = 
{
	zoom: SMap.CONFIG[SMap.DEF_OPHOTO].zoom,
	url: SMap.CONFIG[SMap.DEF_OPHOTO].url,
  options: {animTime: 0, fadeTime: 0, prefetch: 0, alpha: true, opacity: 0.3},
	copyright: SMap.CONFIG[SMap.DEF_OPHOTO].copyright
};

// jiná verze reliéfu (bílá)
SMap.CONFIG["Relief2_ID"] = 
{
	zoom: [3, 17],
	options: {animTime: 0, fadeTime: 0,	prefetch: 0, alpha: true, opacity: 0.25},
  buildUrl: function(t /*tile*/)
  {
    return ("http://geoportal.gov.cz/ArcGIS/services/CENIA/cenia_stinovani/MapServer/WMSServer?"
      + "BBOX=" + t.getBBOX(this.getMap()) + "&WIDTH=" + this._options.tileSize + "&HEIGHT=" + this._options.tileSize
      + "&CRS=" + encodeURIComponent(this.getMap().getProjection().getCode())
      + "&Layers=0&version=1.3.0&service=WMS&format=" + encodeURIComponent("image/png") + "&request=GetMap&styles=");
  },
  projection: SMap.projUTM33
};       

SMap.CONFIG["Vrstevnice_ID"] = 
{
  zoom: [5, 20],
  url: "",
  options: {prefetch: 0, tileSize: 256, gcDelay: (1000 * 3600 * 1), alpha: true, opacity: 0.4, 
    reproject: function(map)
    {
      return (map.getProjection().getCode() != "EPSG:102067");
    }},
  copyright: {"1-": "GeoPortal.gov / ČÚZK"},

  buildUrl: function(t /*tile*/)
  {
    var code = this.getMap().getProjection().getCode();

    // for Mercator we need resolution 1200x420 (which is currently impossible) to prevent white background in WGS84 mode
    if (code != "EPSG:102067")
      code = "EPSG:32633";

    // info: http://directory.spatineo.com/service/3806/
    // Vrstevnice základní (GL_CA010)	
    // Vrstevnice zdůrazněná (GL_CA011)	
    // Vrstevnice doplňková (GL_CA012)

    // higher opacity for OSM maps (forests there decrease contour visibility)
    if (this.getMap().CurrentMapId == "OSM_ID")
      this._options.opacity = 0.7;
    
    var layers = "GL_CA011,GL_CA012";
    
    //if (code == "EPSG:32633" && t.zoom >= 17)
      layers += ",GL_CA010"; 	

    return ("http://geoportal.cuzk.cz/WMS_ZABAGED_PUB/service.svc/get?"
      + "SERVICE=WMS&REQUEST=GetMap&VERSION=1.3.0" + "&LAYERS=" + encodeURIComponent(layers)
      + "&FORMAT=" + encodeURIComponent("image/png") 
      + "&WIDTH=" + t.tileSize + "&HEIGHT=" + t.tileSize + "&BBOX=" + t.getBBOX(this.getMap()) 
      + "&CRS=" + encodeURIComponent(code) + "&STYLES=&TRANSPARENT=TRUE");
  },
  projection: SMap.projUTM33
};

var katastrBuildUrl = function(t, mapType)
{
  var code = this.getMap().getProjection().getCode();
  
  if (code == "EPSG:4326") /* Mercator nevypadá hezky */
    code = "EPSG:32633";
  
  if (code == "oblique")
    return "";

  // http://services.cuzk.cz/wms/wms.asp?&LAYERS=KN&FORMAT=image%2Fpng&TRANSPARENT=true&SERVICE=WMS&VERSION=1.1.1&REQUEST=GetMap&STYLES=&EXCEPTIONS=application%2Fvnd.ogc.se_inimage&SRS=EPSG%3A900913&BBOX=1711981.9297627,6539317.7771327,1712058.366791,6539394.2141609&WIDTH=256&HEIGHT=256
  return ("http://services.cuzk.cz/wms/wms.asp?"
    + "SERVICE=WMS&REQUEST=GetMap&VERSION=1.1.1" + "&LAYERS=" + encodeURIComponent(mapType) + "&FORMAT=" + encodeURIComponent("image/png") 
    + "&WIDTH=" + t.tileSize + "&HEIGHT=" + t.tileSize + "&BBOX=" + t.getBBOX(this.getMap(), "1.1.1") 
    + "&SRS=" + encodeURIComponent(code) + "&STYLES=&TRANSPARENT=true&EXCEPTIONS=" + encodeURIComponent("application/vnd.ogc.se_inimage")); 
}

SMap.CONFIG["Katastr"] = 
{
  url: "",
  options: {animTime: 0, fadeTime: 0, prefetch: 0, alpha: true, tileSize: 256,
    reproject: function(map)
    {
      return (map.getProjection().getCode() != "EPSG:102067");
    }},
  copyright: {"1-": "Podkladová data ČÚZK"},

  buildUrl: function(t /*tile*/)
  {
    // info: http://www.cuzk.cz/Dokument.aspx?PRARESKOD=998&MENUID=0&AKCE=DOC:10-WMS_PRO_KM
    // capabilities: http://services.cuzk.cz/wms/wms.asp?service=WMS&version=1.1.1&request=GetCapabilities
    // DEF_BUDOVY, DEF_PARCELY --> červené/modré nápisy (čitelnější pro nižší rozlišení)
    // KN - katastr černý, KN_I - katastr bílý
    // hranice_parcel_barevne - digitalizovaný katastr
    
    return katastrBuildUrl.apply(this, [t, "KN_I"]);
  },
  projection: SMap.projUTM33
};

SMap.CONFIG["DefinicniBodyBudov"] = 
{
  url: "",
  options: SMap.CONFIG["Katastr"].options,
  copyright: SMap.CONFIG["Katastr"].copyright,

  buildUrl: function(t /*tile*/)
  {
    return katastrBuildUrl.apply(this, [t, "DEF_BUDOVY"]);
  },
  projection: SMap.projUTM33
};

SMap.CONFIG["DefinicniBodyParcel"] = 
{
  url: "",
  options: SMap.CONFIG["Katastr"].options,
  copyright: SMap.CONFIG["Katastr"].copyright,

  buildUrl: function(t /*tile*/)
  {
    return katastrBuildUrl.apply(this, [t, "DEF_PARCELY,hranice_parcel_barevne"]);
  },
  projection: SMap.projUTM33
};

SMap.CONFIG["OSM_ID"] = 
{
  zoom: [2, 17],
  label: "OSM",
  title: "Open Street Maps",
  preview: default_preview_path + "OSM.png",
  url: "http://tile.openstreetmap.org/",
  options: {query: "{zoom}/{x}/{y}.png"},
  copyright: {"1-": "Open Street Maps"},
  projection: SMap.projMercator,
  bBox: SMap.CONFIG.bBox_Mercator
};

SMap.CONFIG["OSMCyclo_ID"] = 
{
  zoom: [2, 17],
  label: "OSM Cyclo",
  title: "OpenCycleMap",
  preview: default_preview_path + "OSM Cyclo.png",
  url: "http://tile.opencyclemap.org/cycle/",
  options: {query: "{zoom}/{x}/{y}.png"},
  copyright: {"1-": "Open Street Maps"},
  projection: SMap.projMercator,
  bBox: SMap.CONFIG.bBox_Mercator
};

SMap.CONFIG["FreemapSK_ID"] = 
{
  zoom: [5, 16],
  label: "Freemap SK",
  title: "Freemap.sk",
  preview: default_preview_path + "FreemapSK.png",
  
  // a. --> can be a/b/c/d
  // T - turistická, A - autoatlas, C - cyklo, K - běžkařská
  // url for K: http://t4.freemap.sk/K/
  
  url: "http://a.freemap.sk/data/layers/presets/T/",  
  options: {query: "{zoom}/{x}/{y}.jpeg"},
  copyright: {"1-": "Freemap.sk"},
  projection: SMap.projMercator,
  bBox: {latMin: 47, latMax: 57.5, lonMin: 0, lonMax: 37}
};

SMap.CONFIG["GSatellite_ID"] = 
{
  zoom: [2, 20],
  label: "Google Satellite",
  title: "Google Satellite Maps",
  preview: default_preview_path + "Google Satellite.jpg",
  
  // note: version (v=???) sometimes changes, so fix it from time to time
  url: "http://khm1.google.com/kh/v=168&",
  options: {query: "x={x}\&y={y}\&z={zoom}"},
  copyright: {"1-": "Google"},
  projection: SMap.projMercator,
  bBox: SMap.CONFIG.bBox_Mercator
};

SMap.CONFIG["GSatelliteSub_ID"] = 
{
  zoom: SMap.CONFIG["GSatellite_ID"].zoom,
  url: SMap.CONFIG["GSatellite_ID"].url,
  options: SMap.CONFIG["GSatellite_ID"].options,
  buildUrl: function(t)
  {
    if (this.getMap().CurrentMapId == "GSatellite_ID")
      this._options.opacity = 1;
      
    // transparent version
    else
    {
      this._options.opacity = 0.3;   
    }
  
    return(this._buildURLOrig(t));  
  },
  copyright: SMap.CONFIG["GSatellite_ID"].copyright,
  projection: SMap.CONFIG["GSatellite_ID"].projection
};

SMap.CONFIG["GMaps_ID"] = 
{
  zoom: [2, 17],
  label: "Google Maps",
  title: "Google Maps",
  preview: default_preview_path + "Google Maps.jpg",
  url: "http://mt2.google.com/vt/hl=cs&",
  options: {query: "x={x}&y={y}&z={zoom}"},
  copyright: {"1-": "Google"},
  projection: SMap.projMercator,
  bBox: SMap.CONFIG.bBox_Mercator
};

SMap.CONFIG["GHybrid_ID"] = 
{
  // use m instead of h to display satellite maps
  url: "http://mt2.google.com/vt/lyrs=h&hl=cs&",
  options: {query: "x={x}&y={y}&z={zoom}", animTime: 0, fadeTime: 0, prefetch: 0, alpha: true},
  copyright: {"1-": "Google"},
  projection: SMap.projMercator
};

SMap.CONFIG["GTerrainSubLayer_ID"] = 
{
  zoom: [2, 15],
  url: "http://mt2.google.com/vt/lyrs=t@900&",
  options: {query: "x={x}&y={y}&z={zoom}", opacity: 0.5},
  copyright: {"1-": "Google"},
  projection: SMap.projMercator
};

SMap.CONFIG["LandShading_ID"] = 
{
  zoom: [2, 15],
  url: "http://tiles.openpistemap.org/landshaded/",
  options: {query: "{zoom}/{x}/{y}.png", opacity: 1},
  copyright: {"1-": "OpenPisteMap"},
  projection: SMap.projMercator
};

SMap.CONFIG["Boundaries_ID"] =   /* hranice krajů, zemí atd., u nás stejné jako vrstva "prehledky" od ČÚZK */
{
  zoom: [6, 18],
  url: "http://129.206.74.245:8007/tms_b.ashx?",
  options: {query: "x={x}&y={y}&z={zoom}", animTime: 0, fadeTime: 0, prefetch: 0, alpha: true},
  copyright: {"1-": "OpenStreetMap"},
  projection: SMap.projMercator
};

SMap.CONFIG["GTerrain_ID"] =   /* musí být pod GTerrainSubLayer_ID, protože se na něj odkazuje */
{
  zoom: [2, 15],
  label: "Google Terrain",
  title: "Google Terrain",
  preview: default_preview_path + "Google Terrain.png",
  url: "http://mt2.google.com/vt/lyrs=t,r&hl=cs&",
  options: {query: "x={x}&y={y}&z={zoom}"},
  copyright: {"1-": "Google"},
  projection: SMap.projMercator,
  bBox: SMap.CONFIG.bBox_Mercator
};

// http://mc.bbbike.org/mc/?lon=15.418542&lat=50.398&zoom=9&num=1&mt0=mapnik&mt1=mapbox-terrain
// https://www.mapbox.com/signup/?plan=starter
SMap.CONFIG["MapBoxTerrain_ID"] = 
{
  zoom: [2, 17],
  label: "MapBox Terrain",
  title: "MapBox Terrain",
  preview: default_preview_path + "MapBox Terrain.png",
  buildUrl: function(t /*tile*/)
  {
    return "http://b.tiles.mapbox.com/v4/matt.72ef5189/" + (t.zoom-1) + "/" + t.x + "/" + t.y + "@2x.png?access_token=pk.eyJ1IjoiZHVuY2FuZ3JhaGFtIiwiYSI6IlJJcWdFczQifQ.9HUpTV1es8IjaGAf_s64VQ";
  },
  options: {prefetch: 0, tileSize: 512},    
  copyright: {"1-": "MapBox"},
  projection: SMap.projMercator,
  bBox: {latMin: -85, latMax: 85, lonMin: -180, lonMax: 180}
};

SMap.CONFIG["GStreetView_ID"] = 
{
  // lmc:photos_outside_streetview_134,svv --> street view + images
  // lmc:panoramio,svv --> street view + panoramio images
  // lmc:,svv --> street view only
  zoom: [2, 20],
  url: "http://mt0.google.com/mapslt?lyrs=lmc:,svv&w=256&h=256&hl=cs&style=40,18&",
  options: {query: "x={x}&y={y}&z={zoom}", animTime: 0, fadeTime: 0, prefetch: 0, alpha: true},
  copyright: {"1-": "Google"},
  projection: SMap.projMercator
};

SMap.CONFIG["GeocachesMap_ID"] = 
{
  zoom: [2, 20],
  url: "http://tiles01.geocaching.com/map/map.png?",
  //options: {query: "x={x}&y={y}&z={zoom}&ep=1", animTime: 0, fadeTime: 0, prefetch: 0, alpha: true},
  options: {query: "x={x}&y={y}&z={zoom}&ep=1", animTime: 0, fadeTime: 0, prefetch: 0, alpha: true, reprojectionZoomLower: true},
  copyright: {"1-": "Groundspeak.com"},
  projection: SMap.projMercator
};


SMap.CONFIG["MTBMap_ID"] = 
{
  zoom: [2, 16],
  label: "MTB Map",
  title: "MTB Map",
  preview: default_preview_path + "MTB Map.png",
  url: "http://tile.mtbmap.cz/mtbmap_tiles/", // www.mtbmap.cz or tile.mtbmap.cz
  options: {query: "{zoom}/{x}/{y}.png"},
  copyright: {"1-": ["<a href=http://MTBMap.cz>MTBMap.cz</a>", "Martin Tesař", "OpenStreetMap"]},
  projection: SMap.projMercator,
  bBox: {latMin: 35, latMax: 60, lonMin: -10, lonMax: 45}
};

// fill in missing zoom range
SMap.CONFIG[SMap.DEF_TRAIL].zoom = [5, 20];
SMap.CONFIG[SMap.DEF_BIKE].zoom = [5, 20];
SMap.CONFIG[SMap.DEF_HYBRID].zoom = [5, 20];

// fill in missing bBox
[SMap.DEF_BASE, SMap.DEF_TURIST, SMap.DEF_OPHOTO, SMap.DEF_HISTORIC, SMap.DEF_OPHOTO0203, 
SMap.DEF_OPHOTO0406, SMap.DEF_SMART_BASE, SMap.DEF_SMART_OPHOTO, SMap.DEF_SMART_TURIST, 
SMap.DEF_TURIST_WINTER, SMap.DEF_SMART_WINTER, SMap.DEF_SUMMER, SMap.DEF_SMART_SUMMER,
SMap.DEF_GEOGRAPHY].forEach(function(mapId)
{
  SMap.CONFIG[mapId].bBox = SMap.CONFIG.bBox_MapyCZ;  
});

// funkce addDefaultLayer se při přidání SMap.DEF_PANO dožaduje addDefaultLayer, což nemusí být dostupné
// -- proto vrstvu zkopírujeme pod jiné ID
// -- také je třeba nastavit průhlednost, jinak se při změně zoomu staré dílky nemažou 
SMap.CONFIG[SMap.DEF_PANO].options.alpha = true;
SMap.CONFIG["pano_ID"] = SMap.CONFIG[SMap.DEF_PANO];

// reliéf použijeme starou vrstvu, dokud ta původní na Mapy.cz opět nefunguje
// *** po odstranění je ještě v mapycz.js nutno odstranit kód kolem řádku 217 ***
SMap.CONFIG[SMap.DEF_RELIEF].zoom = [3, 15];
SMap.CONFIG[SMap.DEF_RELIEF].options.query = "{zoom}_{ppx}_{ppy}";
SMap.CONFIG[SMap.DEF_RELIEF].url = SMap.CONFIG.protocol + "//m#.mapserver.mapy.cz/relief/";
SMap.CONFIG[SMap.DEF_RELIEF].projection = SMap.projUTM33;

window.otherMapsJS_Loaded = true;